#!/usr/bin/perl
#print "Content-type: text/html\n\n";

use DBI;
use DBD::Oracle qw(:ora_types);

require "SYS_PROFILE";                     ## System Profile

require "$BINDIR/cgi-lib2.pl";             ## Perl Handling Sub-routines
require "$BINDIR/currency.pl";             ## Currency Format Sub-routine
require "$BINDIR/DEFAULT_FONTS";           ## Default Fonts
require "$BINDIR/ORACLE_CONNECTION";       ## Oracle DB Connection Routine

if ($dbh eq '') { print "$FA Connection to Oracle Failed."; exit; }

require "$HOMEDIR/security_check.pl";      ## Check Security Access Level
$RC = &security_check;

#if ($ACCESS ne 'A' && $ACCESS ne '!') {
if ($ACCESS eq '') {
    @proglist = ("security_violation.cgi");
    system(@proglist);
    exit;
  }

print "Content-type: text/html\n\n";


&ReadParse(*input);

#print $input;
#exit;

##-----------------------------------------------##
## 
##-----------------------------------------------##

$SCRIPT = '04. ace_recon.cgi';

$BEGDT = `date +%T`;
chop($BEGDT);

$date  = `date +%m/%d/%Y-%T`; 

$SYSD1    = `date +%Y-%m-%d`; 
$SYSD2    = `date +%T`; 
chop($SYSD1);
chop($SYSD2);
$SYSDATE  = $SYSD1." ".$SYSD2;
#print "<PRE>:",$SYSDATE;

$SP = "                                                                      ";
$LIM = "NO";

$NB = " &nbsp; ";
$NW = " nowrap";
$AC = " align=center";
$AL = " align=left";
$AR = " align=right";

$FF1 = "STYLE=font-family:Tahoma;font-size:11px; STYLE=width:100px ";
$FF2 = "STYLE=font-family:Tahoma;font-size:11px; STYLE=width:80px ";
$FF3 = "STYLE=font-family:Tahoma;font-size:11px; STYLE=width:130px ";
$FF4 = "STYLE=font-family:arial;font-size:12px; STYLE=width:120px ";
$FFY = "STYLE=font-family:Tahoma;font-size:11px; STYLE=width:50px ";
$FFM = "STYLE=font-family:Tahoma;font-size:11px; STYLE=width:40px ";
$FFI = "STYLE=font-family:Tahoma;font-size:11px; STYLE=width:140px ";

##------------------------------------------------------------------##
##  CREATE THE DOWNLOAD FILE LINK.                                  ##
##------------------------------------------------------------------##

$date  = `date +%Y/%m/%d-%T`;
$DATE1 = `date +%D`;
$DATE2 = `date +%T`;
$USER  = substr($ENV{'REMOTE_USER'}."          ",0,10);
$USER  =~ tr/a-z/A-Z/;

$UID = $USER;
$UID =~ tr/ /0/;
$UID =~ tr/a-z/A-Z/;
$UID = substr($UID."00000000",0,8)."-".substr($DATE2,6,2);

$UID1 = $UID."-ces";

unlink ("../REPORTS/$UID1.XLS");
open(REPORT1, ">../REPORTS/$UID1.XLS");


if ($input{'RPT'} eq '01') {
    printf (REPORT1 "Broker            \t");
    printf (REPORT1 "Entry-Date        \t");
    printf (REPORT1 "Entry-Numbers     \t");
    printf (REPORT1 "Quantity          \t");
    printf (REPORT1 "Entered Value     \t");
    printf (REPORT1 "Estd Duty         \t");
    printf (REPORT1 " \n");
   }


if ($input{'RPT'} eq '02') {
    printf (REPORT1 "Broker            \t");
    printf (REPORT1 "Entry-Date        \t");
    printf (REPORT1 "Entry-Number      \t");
    printf (REPORT1 "Entry-Lines       \t");
    printf (REPORT1 "Quantity          \t");
    printf (REPORT1 "Entered Value     \t");
    printf (REPORT1 "Estd Duty         \t");
    printf (REPORT1 " \n");
   }


if ($input{'RPT'} eq '03') {
    printf (REPORT1 "Broker            \t");
    printf (REPORT1 "Entry-Date        \t");
    printf (REPORT1 "Entry-Number      \t");
    printf (REPORT1 "Line-Nbr          \t");
    printf (REPORT1 "Import-Nbr        \t");
    printf (REPORT1 "Entry-Type        \t");
    printf (REPORT1 "Create-Date       \t");
    printf (REPORT1 "Export-Ctry       \t");
    printf (REPORT1 "Import-Ctry       \t");
    printf (REPORT1 "Import-Port       \t");
    printf (REPORT1 "Imp-Acct-Nbr      \t");
    printf (REPORT1 "HTS-Code          \t");
    printf (REPORT1 "Quantity          \t");
    printf (REPORT1 "Entered Value     \t");
    printf (REPORT1 "Estd Duty         \t");
    printf (REPORT1 " \n");
   }


##-------------------------------------------------------##
## Get FILTERS for Drop Down List Boxes                  ##
##-------------------------------------------------------##

$sql_cmd = "
select distinct key1, data1     
  from genfin_dbo.tces_filters
 where table_name = 'ACE'
 order by 1, 2
 ";

#print "<PRE>cmd:",$sql_cmd;
#exit;

$stmt = $dbh->prepare("
 $sql_cmd
     ") or DBI::errstr;

$stmt->execute;


@FILTa = ''; ## SHIPDATE
@FILTb = ''; ## IMPORTDATE
@FILTc = ''; ## EXPORTDATE
@FILTd = ''; ## IMPORTPORT
@FILTe = ''; ## DOCTYPE
@FILTf = ''; ## BROKER
@FILTg = ''; ## ENTRYCLASS
@FILTh = ''; ## DUTYTYPE
@FILTi = ''; ## CTRYEXP
@FILTj = ''; ## UPLOADDATE
@FILTk = ''; ## DATE-YYYY
@FILTl = ''; ## DATE-MM
@FILTm = ''; ## DATE-DD

$i=0;
$ia=0;
$ib=0;
$ic=0;
$id=0;
$ie=0;
$if=0;
$ig=0;
$ih=0;
$ii=0;
$ij=0;
$ik=0;
$il=0;
$im=0;


while ( @data = $stmt->fetchrow_array() ) {

   if ($data[0] eq 'SHIPDATE  ') {
      $FILTa[$ia] = $data[1];
      $ia++;
      }

   if ($data[0] eq 'IMPORTDATE') {
      $FILTb[$ib] = $data[1];
      $ib++;
      }

   if ($data[0] eq 'EXPORTDATE') {
      $FILTc[$ic] = $data[1];
      $ic++;
      }

   if ($data[0] eq 'IMPORTPORT') {
      $FILTd[$id] = $data[1];
      $id++;
      }

   if ($data[0] eq 'DOCTYPE   ') {
      $FILTe[$ie] = $data[1];
      $ie++;
      }

   if ($data[0] eq 'BROKER    ') {
      $FILTf[$if] = $data[1];
      $if++;
      }

   if ($data[0] eq 'ENTRYCLASS') {
      $FILTg[$ig] = $data[1];
      $ig++;
      }

   if ($data[0] eq 'DUTYTYPE  ') {
      $FILTh[$ih] = $data[1];
      $ih++;
      }

   if ($data[0] eq 'CTRYEXP   ') {
      $FILTi[$ii] = $data[1];
      $ii++;
      }

   if ($data[0] eq 'UPLOADDATE') {
      $FILTj[$ij] = $data[1];
      $ij++;
      }

   if ($data[0] eq 'DATE-YYYY ') {
      $FILTk[$ik] = $data[1];
      $ik++;
      }

   if ($data[0] eq 'DATE-MM   ') {
      $FILTl[$il] = $data[1];
      $il++;
      }

   if ($data[0] eq 'DATE-DD   ') {
      $FILTm[$im] = $data[1];
      $im++;
      }

   $i++;

   }

$stmt->finish;

if ($i eq 0) {
   print "<P>$F0<B> FILTER LOAD FAILED";
   exit;
   }

#print " <PRE>A:",$ia;
#print " <PRE>B:",$ib;
#print " <PRE>C:",$ic;
#print " <PRE>D:",$id;
#print " <PRE>E:",$ie;
#print " <PRE>F:",$if;
#print " <PRE>G:",$ig;
#print " <PRE>H:",$ih;
#print " <PRE>I:",$ii;
#print " <PRE>J:",$ij;
#print " <PRE>K:",$ik;
#print " <PRE>L:",$il;
#print " <PRE>M:",$im;
#exit;

if ($input eq '') {
   $input{'TIF'} = 'ALL';
   $input{'IAN'} = 'ALL';
   $input{'LTN'} = 'ALL';
   $input{'SHP'} = 'ALL';
   $input{'CCN'} = 'ALL';
   $input{'HTS'} = 'ALL';
   $input{'SHD'} = '__________';
   $input{'IMD'} = '__________';
   $input{'EXD'} = '__________';
   $input{'DT1'} = 'ALL';
   $input{'SL1'} = 'ALL';
   $input{'EC1'} = 'ALL';
   $input{'DT2'} = 'ALL';
   $input{'EC2'} = 'ALL';
   $input{'IPP'} = 'ALL';
   $input{'UPD'} = 'ALL';
   }


$input{'TIF'} =~ tr/a-z/A-Z/;
$input{'IAN'} =~ tr/a-z/A-Z/;
$input{'LTN'} =~ tr/a-z/A-Z/;
$input{'SHP'} =~ tr/a-z/A-Z/;
$input{'CCN'} =~ tr/a-z/A-Z/;
$input{'HTS'} =~ tr/a-z/A-Z/;

$input{'IMD'} = $input{'IMYY'}."/".$input{'IMMM'}."/".$input{'IMDD'};
$input{'SHD'} = $input{'SHYY'}."/".$input{'SHMM'}."/".$input{'SHDD'};
$input{'EXD'} = $input{'EXYY'}."/".$input{'EXMM'}."/".$input{'EXDD'};

if ($input{'IMD'} ne '____/__/__' &&
    $input{'SHD'} eq '____/__/__') { 
    $input{'SHD'}  = $input{'IMD'};
    $input{'SHYY'} = $input{'IMYY'};
    $input{'SHMM'} = $input{'IMMM'};
    $input{'SHDD'} = $input{'IMDD'};
   }

##--------------------------##
## PRINT THE HEADER TABS
##--------------------------##
require "$BINDIR/HEADER_TABS";       ## Print out Header TABS.



print <<ENDOFFILE;
<TABLE width=760 border=1 cellpadding=2 cellspacing=0>
<TR><TD>
<TABLE width=100% background=../images/CES-BACK.gif border=0 cellpadding=0 cellspacing=0>

<TR $VAM height=38>
<TD nowrap align=left $CS=4> $F1<b> $NB ACE RECONCILIATION </TD>
ENDOFFILE


if ($input ne "") {
print <<ENDOFFILE;
<TD $AR><A HREF="../REPORTS/$UID1.XLS"><font color="#FFFFFF"><img src="../images/excel0.gif" border=0><font face=tahoma color="#0000FF" size=-1><b> Excel</A></TD>
ENDOFFILE
   }
else {
print <<ENDOFFILE;
<TD>
ENDOFFILE
   }

print <<ENDOFFILE;
<FORM ACTION=ace_recon.cgi METHOD=POST>
<TD $NW $AR $CS=1> $F1<INPUT TYPE=SUBMIT VALUE=Reset> $NB $NB </TD>
</TD>
</FORM>
ENDOFFILE


print <<ENDOFFILE;
</TABLE>
</TABLE>
<TABLE border=1 cellpadding=2 cellspacing=0 width=760>
<TR><TD>
<TABLE width=100% background=../images/CES-BACK.gif border=0 cellpadding=1 cellspacing=2>
ENDOFFILE


print <<ENDOFFILE;

<FORM ACTION=ace_recon.cgi METHOD=POST>
ENDOFFILE

$HREFD = "<A HREF=Custom_Sched_D.html><font color=blue>";
$HENDD = "</A>";
$HREF3 = "<A HREF=ISO-3166-CODES-A.html><font color=blue>";
$HEND3 = "</A>";

$HDGMGR = '';

print <<ENDOFFILE;
<TR valign=bottom>
<TD nowrap align=right> $F1<b> Broker
<TD nowrap align=left><SELECT NAME=BRK $FF1>
<OPTION VALUE='%'>ALL
ENDOFFILE

$i=0;
do {
   if ($if ne 0) {
      $_ = $FILTf[$i];
      $SEL1 = '';
      if ($_ eq $input{'BRK'}) { $SEL1 = 'SELECTED'; }
      print "<OPTION VALUE='$_' $SEL1>",$_;
      $i++;
     }
   } while ($i ne $if);

print <<ENDOFFILE;
</SELECT>
ENDOFFILE

##-----------##

print <<ENDOFFILE;
<TD nowrap align=right> $F1<b> Import Date from
ENDOFFILE

##-----------##

print <<ENDOFFILE;
<TD $NW>
<SELECT NAME=IMYY $FFY>
<OPTION VALUE="____">YYYY
ENDOFFILE

$i=0;
do {
   if ($ik ne 0) {
      $_ = $FILTk[$i];
      $SEL1 = '';
      if ($_ eq $input{'IMYY'}) { $SEL1 = 'SELECTED'; }
      print "<OPTION VALUE='$_' $SEL1>",$_;
      $i++;
     }
   } while ($i ne $ik);

print <<ENDOFFILE;
</SELECT>
ENDOFFILE

print <<ENDOFFILE;
<SELECT NAME=IMMM $FFM>
<OPTION VALUE="__">MM 
ENDOFFILE

$i=0;
do {
   if ($il ne 0) {
      $_ = $FILTl[$i];
      $SEL1 = '';
      if ($_ eq $input{'IMMM'}) { $SEL1 = 'SELECTED'; }
      print "<OPTION VALUE='$_' $SEL1>",$_;
      $i++;
     }
   } while ($i ne $il);

print <<ENDOFFILE;
</SELECT>
ENDOFFILE

print <<ENDOFFILE;
<SELECT NAME=IMDD $FFM>
<OPTION VALUE="__">DD 
ENDOFFILE

$i=0;
do {
   if ($im ne 0) {
      $_ = $FILTm[$i];
      $SEL1 = '';
      if ($_ eq $input{'IMDD'}) { $SEL1 = 'SELECTED'; }
      print "<OPTION VALUE='$_' $SEL1>",$_;
      $i++;
     }
   } while ($i ne $im);

print <<ENDOFFILE;
</SELECT></TD>
ENDOFFILE

##-----------##

$SEL1 = '';
$SEL2 = '';
$SEL3 = '';
if ($input{'MT1'} eq '01') { $SEL1 = ' SELECTED'; }
if ($input{'MT1'} eq '02') { $SEL2 = ' SELECTED'; }
if ($input{'MT1'} eq '03') { $SEL3 = ' SELECTED'; }

print <<ENDOFFILE;
<TD nowrap align=right> $F1<b> Match 
<TD><SELECT NAME=MT1 $FF3></STYLE>
<OPTION VALUE='01' $SEL1>01. ACE not in CES
<OPTION VALUE='02' $SEL2>02. CES not in ACE
<OPTION VALUE='03' $SEL3>03. ACE equal CES
</SELECT></TD>
ENDOFFILE

##-----------##

print <<ENDOFFILE;
<TR $VAB>
<TD nowrap align=right> $F1<b> Entry Number   
ENDOFFILE

##-----------##

print <<ENDOFFILE;
<TD><INPUT TYPE=TEXT MAXLENGTH=15 size=15 NAME=CCN VALUE='$input{'CCN'}' $FF1>
ENDOFFILE

##-----------##

print <<ENDOFFILE;
<TD nowrap align=right> $F1<b> Import Date thru
ENDOFFILE

##-----------##

print <<ENDOFFILE;
<TD $NW>
<SELECT NAME=SHYY $FFY>
<OPTION VALUE="____">YYYY
ENDOFFILE

$i=0;
do {
   if ($ik ne 0) {
      $_ = $FILTk[$i];
      $SEL1 = '';
      if ($_ eq $input{'SHYY'}) { $SEL1 = 'SELECTED'; }
      print "<OPTION VALUE='$_' $SEL1>",$_;
      $i++;
     }
   } while ($i ne $ik);

print <<ENDOFFILE;
</SELECT>
ENDOFFILE

print <<ENDOFFILE;
<SELECT NAME=SHMM $FFM>
<OPTION VALUE="__">MM 
ENDOFFILE

$i=0;
do {
   if ($il ne 0) {
      $_ = $FILTl[$i];
      $SEL1 = '';
      if ($_ eq $input{'SHMM'}) { $SEL1 = 'SELECTED'; }
      print "<OPTION VALUE='$_' $SEL1>",$_;
      $i++;
     }
   } while ($i ne $il);

print <<ENDOFFILE;
</SELECT>
ENDOFFILE

print <<ENDOFFILE;
<SELECT NAME=SHDD $FFM>
<OPTION VALUE="__">DD 
ENDOFFILE

$i=0;
do {
   if ($im ne 0) {
      $_ = $FILTm[$i];
      $SEL1 = '';
      if ($_ eq $input{'SHDD'}) { $SEL1 = 'SELECTED'; }
      print "<OPTION VALUE='$_' $SEL1>",$_;
      $i++;
     }
   } while ($i ne $im);

print <<ENDOFFILE;
</SELECT></TD>
ENDOFFILE

##-----------##

$SEL1 = '';
$SEL2 = '';
$SEL3 = '';
if ($input{'RPT'} eq '01') { $SER1 = ' SELECTED'; }
if ($input{'RPT'} eq '02') { $SER2 = ' SELECTED'; }
if ($input{'RPT'} eq '03') { $SER3 = ' SELECTED'; }

print <<ENDOFFILE;
<TD nowrap align=right> $F1<b> Report
<TD><SELECT NAME=RPT $FF3></STYLE>
<OPTION VALUE='01' $SER1>01. Summary by Date
<OPTION VALUE='02' $SER2>02. Summary by Entry Nbr
<OPTION VALUE='03' $SER3>03. Detail Report
</SELECT></TD>
ENDOFFILE

##-----------##

print <<ENDOFFILE;
<TR $VAM>
<TD nowrap align=right> $F1<b>$HREF3 Exporting Country $HEND3
ENDOFFILE

##-----------##

print <<ENDOFFILE;
<TD><SELECT NAME=EC2 $FF1>
<OPTION VALUE="ALL">ALL
ENDOFFILE

$i=0;
do {
   if ($ii ne 0) {
      $_ = $FILTi[$i];
      $SEL1 = '';
      if ($_ eq $input{'EC2'}) { $SEL1 = 'SELECTED'; }
      print "<OPTION VALUE='$_' $SEL1>",$_;
      $i++;
     }
   } while ($i ne $ii);

print <<ENDOFFILE;
</SELECT></TD>
ENDOFFILE

##-----------##

print <<ENDOFFILE;
<TD nowrap align=right> $F1<b> $HREFD Import Port $HENDD
ENDOFFILE

##-----------##

print <<ENDOFFILE;
<TD><SELECT NAME=IPP $FF1>
<OPTION VALUE="ALL">ALL
ENDOFFILE

$i=0;
do {
   if ($id ne 0) {
      $_ = $FILTd[$i];
      $SEL1 = '';
      if ($_ eq $input{'IPP'}) { $SEL1 = 'SELECTED'; }
      print "<OPTION VALUE='$_' $SEL1>",$_;
      $i++;
     }
   } while ($i ne $id);

print <<ENDOFFILE;
</SELECT></TD>
ENDOFFILE

##-----------##

print <<ENDOFFILE;
<TD nowrap align=right> $F1<b> HTS Code
<TD><INPUT TYPE=TEXT MAXLENGTH=12 size=12 NAME=HTS VALUE='$input{'HTS'}' $FF2>
    $NB <INPUT TYPE=SUBMIT VALUE=Search> </TD>
ENDOFFILE

##-----------##

## IF NO INPUT EXIT       
if ($input eq "") {
   exit;
   }

print <<ENDOFFILE;
</TABLE>

</TABLE>
ENDOFFILE

if ($input{'RPT'} eq '01') {
print <<ENDOFFILE;
<TABLE border=0 cellpadding=2 cellspacing=1>
<TR $VAB>
<TD $NW $AL width=75> $F1<b> Broker
<TD $NW $AL width=75> $F1<b> Entry Date   
<TD $NW $AL width=95> $F1<b> Entry Numbers
<TD $NW $AR width=95> $F1<b> Quantity
<TD $NW $AR width=95> $F1<b> Entered Value
<TD $NW $AR width=95> $F1<b> Estd Duty 
ENDOFFILE
   }


if ($input{'RPT'} eq '02') {
print <<ENDOFFILE;
<TABLE border=0 cellpadding=2 cellspacing=1>
<TR $VAB>
<TD $NW $AL width=75> $F1<b> Broker
<TD $NW $AL width=75> $F1<b> Entry Date   
<TD $NW $AL> $F1<b> Entry Number 
<TD $NW $AR width=75> $F1<b> Entry Lines  
<TD $NW $AR width=95> $F1<b> Quantity
<TD $NW $AR width=95> $F1<b> Entered Value
<TD $NW $AR width=95> $F1<b> Estd Duty 
ENDOFFILE
   }


if ($input{'RPT'} eq '03') {
print <<ENDOFFILE;
<TABLE border=0 cellpadding=2 cellspacing=1>
<TR $VAB>
<TD $NW $AL width=75> $F1<b> Broker
<TD $NW $AL width=75> $F1<b> Entry Date   
<TD $NW $AL width=75> $F1<b> Entry Number 
<TD $NW $AL > $F1<b> Line Nbr     
<TD $NW $AL width=95> $F1<b> Import Nbr     
<TD $NW $AL > $F1<b> Entry Type   
<TD $NW $AL > $F1<b> Create Date  
<TD $NW $AL > $F1<b> Ctry of Exp  
<TD $NW $AL > $F1<b> Ctry of Orig 
<TD $NW $AL > $F1<b> Imp Acct Nbr 
<TD $NW $AL > $F1<b> Import Port
<TD $NW $AL > $F1<b> HTS Code    
<TD $NW $AR width=95> $F1<b> Quantity
<TD $NW $AR width=95> $F1<b> Entered Value
<TD $NW $AR width=95> $F1<b> Estd Duty 
ENDOFFILE
   }

$input{'IMD'} = $input{'IMYY'}."/".$input{'IMMM'}."/".$input{'IMDD'};
$input{'SHD'} = $input{'SHYY'}."/".$input{'SHMM'}."/".$input{'SHDD'};
$input{'EXD'} = $input{'EXYY'}."/".$input{'EXMM'}."/".$input{'EXDD'};

if ($input{'IMD'} eq '____/__/__') { $input{'IMD'} = '0000/00/00'; }
if ($input{'SHD'} eq '____/__/__') { $input{'SHD'} = '9999/99/99'; }

$INBRK =   $input{'BRK'};
$INIAN =   $input{'IAN'};
$INLTN =   $input{'LTN'};
$INSHP =   $input{'SHP'};
$INCCN =   $input{'CCN'};
$INHTS =   $input{'HTS'};
$INSHD =   $input{'SHD'};
$INIMD =   $input{'IMD'};
$INEXD =   $input{'EXD'};
$INDT1 =   $input{'DT1'};
$INSL1 =   $input{'SL1'};
$INEC1 =   $input{'EC1'};
$INDT2 =   $input{'DT2'};
$INEC2 =   $input{'EC2'};
$INIPP =   $input{'IPP'};
$INUPD =   $input{'UPD'};

$INBRK =~ tr/*/%/;
$INIAN =~ tr/*/%/;
$INLTN =~ tr/*/%/;
$INSHP =~ tr/*/%/;
$INCCN =~ tr/*/%/;
$INHTS =~ tr/*/%/;

if (substr($INBRK,0,3) eq 'ALL') { $INBRK = '%'; }
if (substr($INIAN,0,3) eq 'ALL') { $INIAN = '%'; }
if (substr($INLTN,0,3) eq 'ALL') { $INLTN = '%'; }
if (substr($INSHP,0,3) eq 'ALL') { $INSHP = '%'; }
if (substr($INCCN,0,3) eq 'ALL') { $INCCN = '%'; }
if (substr($INHTS,0,3) eq 'ALL') { $INHTS = '%'; }
if (substr($INSHD,0,3) eq 'ALL') { $INSHD = '%'; }
if (substr($INIMD,0,3) eq 'ALL') { $INIMD = '%'; }
if (substr($INEXD,0,3) eq 'ALL') { $INEXD = '%'; }
if (substr($INDT1,0,3) eq 'ALL') { $INDT1 = '%'; }
if (substr($INSL1,0,3) eq 'ALL') { $INSL1 = '%'; }
if (substr($INEC1,0,3) eq 'ALL') { $INEC1 = '%'; }
if (substr($INDT2,0,3) eq 'ALL') { $INDT2 = '%'; }
if (substr($INEC2,0,3) eq 'ALL') { $INEC2 = '%'; }
if (substr($INIPP,0,3) eq 'ALL') { $INIPP = '%'; }
if (substr($INUPD,0,3) eq 'ALL') { $INUPD = '%'; }

if (substr($INCCN.$SP,0,10) eq '          ') { $INCCN = '%'; }
if (substr($INHTS.$SP,0,10) eq '          ') { $INHTS = '%'; }
if (substr($INLTN.$SP,0,10) eq '          ') { $INLTN = '%'; }
if (substr($INIAN.$SP,0,10) eq '          ') { $INIAN = '%'; }
if (substr($INSHP.$SP,0,10) eq '          ') { $INSHP = '%'; }


##------------------------------------------------------------------##
##  Create REPORT.                                                 ##
##------------------------------------------------------------------##

$NOT = '';
if ($input{'MT1'} eq '01') { $NOT =  ' not '; }
if ($input{'MT1'} eq '02') { $NOT =  ' not '; }

if ($input{'MT1'} eq '02') { goto REPORT_CES; }

##--------##
##   01. 
##--------##

$sql_cmd = "
select broker
     , entry_date
     , to_char(count(distinct entry_nbr), '999,999,990')
     , to_char(sum(import_qty), '999,999,990')
     , to_char(sum(import_amt), '999,999,990.99')
     , nvl(to_char(sum(import_duty), '999,999,990.99'),'           0.00')
  from genfin_dbo.tces_ace a
 where $NOT exists
     ( select * from genfin_dbo.tces_doc b
        where a.entry_nbr = b.entry_nbr
     )
   and broker           like '$INBRK'
   and entry_nbr        like '$INCCN'
   and hts_code         like '$INHTS'
   and entry_date       between '$INIMD' and '$INSHD'
   and import_port      like '$INIPP'
   and ctry_exp         like '$INEC2'
   and hts_code         not like '9999%'
 group by broker
        , entry_date
union
select '~'    
     , 'Total'    
     , to_char(count(distinct entry_nbr), '999,999,990')
     , to_char(sum(import_qty), '999,999,990')
     , to_char(sum(import_amt), '999,999,990.99')
     , nvl(to_char(sum(import_duty), '999,999,990.99'),'           0.00')
  from genfin_dbo.tces_ace a
 where $NOT exists
     ( select * from genfin_dbo.tces_doc b
        where a.entry_nbr = b.entry_nbr
          and a.broker    = b.broker   
     )
   and broker           like '$INBRK'
   and entry_nbr        like '$INCCN'
   and hts_code         like '$INHTS'
   and entry_date       between '$INIMD' and '$INSHD'
   and import_port      like '$INIPP'
   and ctry_exp         like '$INEC2'
   and hts_code         not like '9999%'
 order by 1, 2, 3
    ";


##--------##
##   02. 
##--------##

if ($input{'RPT'} eq '02') {
$sql_cmd = "
select broker
     , entry_date
     , entry_nbr
     , to_char(count(entry_nbr), '999,999,990')
     , to_char(sum(import_qty), '999,999,990')
     , to_char(sum(import_amt), '999,999,990.99')
     , nvl(to_char(sum(import_duty), '999,999,990.99'),'           0.00')
  from genfin_dbo.tces_ace a
 where $NOT exists
     ( select * from genfin_dbo.tces_doc b
        where a.entry_nbr = b.entry_nbr
          and a.broker    = b.broker
     )
   and broker           like '$INBRK'
   and entry_nbr        like '$INCCN'
   and hts_code         like '$INHTS'
   and entry_date       between '$INIMD' and '$INSHD'
   and import_port      like '$INIPP'
   and ctry_exp         like '$INEC2'
   and hts_code         not like '9999%'
 group by broker
        , entry_date
        , entry_nbr
union
select '~'    
     , '~'    
     , 'Total'    
     , to_char(count(entry_nbr), '999,999,990')
     , to_char(sum(import_qty), '999,999,990')
     , to_char(sum(import_amt), '999,999,990.99')
     , nvl(to_char(sum(import_duty), '999,999,990.99'),'           0.00')
  from genfin_dbo.tces_ace a
 where $NOT exists
     ( select * from genfin_dbo.tces_doc b
        where a.entry_nbr = b.entry_nbr
          and a.broker    = b.broker
     )
   and broker           like '$INBRK'
   and entry_nbr        like '$INCCN'
   and hts_code         like '$INHTS'
   and entry_date       between '$INIMD' and '$INSHD'
   and import_port      like '$INIPP'
   and ctry_exp         like '$INEC2'
   and hts_code         not like '9999%'
 order by 1, 2, 3
    ";
   }


##--------##
##   03. 
##--------##

if ($input{'RPT'} eq '03') {
$sql_cmd = "
select broker
     , entry_date
     , entry_nbr
     , line_nbr
     , import_nbr
     , entry_code
     , create_date
     , ctry_exp
     , ctry_imp
     , import_acct_nbr
     , import_port
     , hts_code
     , to_char((import_qty), '999,999,990')
     , to_char((import_amt), '999,999,990.99')
     , nvl(to_char((import_duty), '999,999,990.99'),'           0.00')
  from genfin_dbo.tces_ace a
 where $NOT exists
     ( select * from genfin_dbo.tces_doc b
        where a.entry_nbr = b.entry_nbr
          and a.broker    = b.broker
     )
   and broker           like '$INBRK'
   and entry_nbr        like '$INCCN'
   and hts_code         like '$INHTS'
   and entry_date       between '$INIMD' and '$INSHD'
   and import_port      like '$INIPP'
   and ctry_exp         like '$INEC2'
   and hts_code         not like '9999%'
 order by 1, 2, 3
    ";
   }

goto NEXT01;


REPORT_CES:

##--------##
##   01. 
##--------##

$sql_cmd = "
select broker
     , import_date
     , to_char(count(distinct entry_nbr), '999,999,990')
     , '~'
     , '~'
     , '~'
  from genfin_dbo.tces_doc a
 where $NOT exists
     ( select * from genfin_dbo.tces_ace b
        where a.entry_nbr = b.entry_nbr
          and a.broker    = b.broker
          and hts_code    like '$INHTS'
     )
   and broker           like '$INBRK'
   and entry_nbr        like '$INCCN'
   and import_date      between '$INIMD' and '$INSHD'
   and import_port      like '$INIPP'
   and ctry_exp              like '$INEC2'
 group by broker
        , import_date
union
select '~'    
     , 'Total'    
     , to_char(count(distinct entry_nbr), '999,999,990')
     , '~'
     , '~'
     , '~'
  from genfin_dbo.tces_doc a
 where $NOT exists
     ( select * from genfin_dbo.tces_ace b
        where a.entry_nbr = b.entry_nbr
          and hts_code         like '$INHTS'
     )
   and broker           like '$INBRK'
   and entry_nbr        like '$INCCN'
   and import_date      between '$INIMD' and '$INSHD'
   and import_port      like '$INIPP'
   and ctry_exp         like '$INEC2'
 order by 1, 2, 3
    ";


##--------##
##   02. 
##--------##

if ($input{'RPT'} eq '02') {
$sql_cmd = "
select broker
     , import_date
     , entry_nbr
     , to_char(count(entry_nbr), '999,999,990')
     , '~'
     , '~'
     , '~'
  from genfin_dbo.tces_doc a
 where $NOT exists
     ( select * from genfin_dbo.tces_ace b
        where a.entry_nbr = b.entry_nbr
          and hts_code         like '$INHTS'
     )
   and broker           like '$INBRK'
   and entry_nbr        like '$INCCN'
   and import_date      between '$INIMD' and '$INSHD'
   and import_port      like '$INIPP'
   and ctry_exp         like '$INEC2'
 group by broker
        , import_date
        , entry_nbr
union
select '~'    
     , '~'    
     , 'Total'    
     , to_char(count(entry_nbr), '999,999,990')
     , '~'
     , '~'
     , '~'
  from genfin_dbo.tces_doc a
 where $NOT exists
     ( select * from genfin_dbo.tces_ace b
        where a.entry_nbr = b.entry_nbr
          and a.broker    = b.broker
          and hts_code         like '$INHTS'
     )
   and broker           like '$INBRK'
   and entry_nbr        like '$INCCN'
   and import_date      between '$INIMD' and '$INSHD'
   and import_port      like '$INIPP'
   and ctry_exp         like '$INEC2'
 order by 1, 2, 3
    ";
   }


##--------##
##   03. 
##--------##

if ($input{'RPT'} eq '03') {
$sql_cmd = "
select broker 
     , import_date
     , entry_nbr
     , shipment_no 
     , import_acct_no
     , import_date
     , export_date
     , ctry_exp
     , '~'       
     , import_acct_no
     , import_port
     , '~'
     , '~'
     , '~'
     , '~'
  from genfin_dbo.tces_doc a
 where $NOT exists
     ( select * from genfin_dbo.tces_ace b
        where a.entry_nbr = b.entry_nbr
          and a.broker    = b.broker
          and hts_code         like '$INHTS'
     )
   and broker           like '$INBRK'
   and entry_nbr        like '$INCCN'
   and import_date      between '$INIMD' and '$INSHD'
   and import_port      like '$INIPP'
   and ctry_exp         like '$INEC2'
 order by 1, 2, 3
    ";
   }


NEXT01:

#print "<TR><TD colspan=16><PRE>CMD:",$sql_cmd;
#exit;


$stmt = $dbh->prepare("
 $sql_cmd
     ") or DBI::errstr;

$stmt->execute;

$i=0;
while ( @data = $stmt->fetchrow_array() ) {

$data[0] =~ s/\/workarea\/j281sc\///gi;

printf (REPORT1 "%s\t%s\t%s\t%s\t%s\t%s\t%s\t%s\t%s\t%s\t%s\t%s\t%s\t%s\t%s\t%s\t \n",$data[0],$data[1],$data[2],$data[3],$data[4],$data[5],$data[6],$data[7],$data[8],$data[9],$data[10],$data[11],$data[12],$data[13],$data[14],$data[15]);

 $i++ ;

$KEY1 = $data[0];
$KEY1 =~ s/ //gi;
$LENG = $data[14];
$LENG =~ s/ //gi;
$LENG =~ s/\,//gi;

$IM_YY = substr($data[1],0,4);
$IM_MM = substr($data[1],5,2);
$IM_DD = substr($data[1],8,2);
$SH_YY = substr($data[1],0,4);
$SH_MM = substr($data[1],5,2);
$SH_DD = substr($data[1],8,2);

$DATA2 = $data[2];
$DATA2 =~ tr/ /+/;

$DATA0 = $data[0];
$DATA0 =~ tr/ /+/;

$HREF1 = ''; 
$HEND1 = '';

if ($input{'RPT'} eq '01') {
   $HREF1 = "<A HREF=ace_recon.cgi?&BRK=$DATA0&CCN=$input{'CCN'}&MT1=$input{'MT1'}&RPT=02&EC2=$input{'EC2'}&IPP=$input{'IPP'}&IMYY=$IM_YY&IMMM=$IM_MM&IMDD=$IM_DD&SHYY=$SH_YY&SHMM=$SH_MM&SHDD=$SH_DD&HTS=$input{'HTS'}><font color=#0000FF>";
   $HEND1 = "</A>";

   if (substr($data[1],0,5) eq 'Total') { $HREF1 = ''; $HEND1 = ''; $i--; }

print <<ENDOFFILE;
<TR>
<TD $NW> $F1 $data[0] $NB
<TD $NW> $F1 $HREF1 $data[1] $HEND1
<TD $NW $AR> $F1 $data[2] $NB
<TD $NW $AR> $F1 $data[3] $NB
<TD $NW $AR> $F1 $data[4] $NB
<TD $NW $AR> $F1 $data[5] $NB
ENDOFFILE
   }

if ($input{'RPT'} eq '02') {
#  $HREF1 = "<A HREF=ace_recon.cgi?&BRK=$DATA0&CCN=$input{'CCN'}&MT1=$input{'MT1'}&RPT=03&EC2=$input{'EC2'}&IPP=$input{'IPP'}&IMYY=$IM_YY&IMMM=$IM_MM&IMDD=$IM_DD&SHYY=$SH_YY&SHMM=$SH_MM&SHDD=$SH_DD&HTS=$input{'HTS'}><font color=#0000FF>";
#  $HEND1 = "</A>";

   $HREF2 = "<A HREF=ace_recon.cgi?&BRK=$DATA0&CCN=$DATA2&MT1=$input{'MT1'}&RPT=03&EC2=$input{'EC2'}&IPP=$input{'IPP'}&IMYY=$IM_YY&IMMM=$IM_MM&IMDD=$IM_DD&SHYY=$SH_YY&SHMM=$SH_MM&SHDD=$SH_DD&HTS=$input{'HTS'}><font color=#0000FF>";
   $HEND2 = "</A>";

   if (substr($data[2],0,5) eq 'Total') { $HREF1 = ''; $HEND1 = ''; 
                                          $HREF2 = ''; $HEND2 = ''; $i--; }

print <<ENDOFFILE;
<TR>
<TD $NW> $F1 $data[0] $NB
<TD $NW> $F1 $HREF1 $data[1] $HEND1
<TD $NW $AL> $F1 $HREF2 $data[2] $HEND2 $NB
<TD $NW $AR> $F1 $data[3] $NB
<TD $NW $AR> $F1 $data[4] $NB
<TD $NW $AR> $F1 $data[5] $NB
<TD $NW $AR> $F1 $data[6] $NB
ENDOFFILE
   }

if ($input{'RPT'} eq '03') {

   if ($input{'MT1'} eq '02' ||
       $input{'MT1'} eq '03') { 
   $HREF1 = "<A HREF=customs_menu.cgi?&BRK=$DATA0&CCN=$DATA2&EC2=$input{'EC2'}&IPP=$input{'IPP'}&IAN=ALL&LTN=ALL&SHP=ALL&IMYY=____&IMMM=__&IMDD=__&SHYY=____&SHMM=__&SHDD=__&EXYY=____&EXMM=__&EXDD=__&EC1=ALL&DT1=ALL&DT2=ALL&UPD=ALL&HTS=$input{'HTS'}><font color=#0000FF>";
   $HEND1 = "</A>";
   }

print <<ENDOFFILE;
<TR>
<TD $NW> $F1 $data[0] 
<TD $NW> $F1 $data[1] $NB
<TD $NW $AL> $F1 $HREF1 $data[2] $HEND1 $NB
<TD $NW $AR> $F1 $data[3] $NB
<TD $NW $AL> $F1 $data[4] $NB
<TD $NW $AC> $F1 $data[5] $NB
<TD $NW $AC> $F1 $data[6] $NB
<TD $NW $AC> $F1 $data[7] $NB
<TD $NW $AC> $F1 $data[8] $NB
<TD $NW $AL> $F1 $data[9] $NB
<TD $NW $AC> $F1 $data[10] $NB
<TD $NW $AL> $F1 $data[11] $NB
<TD $NW $AR> $F1 $data[12] $NB
<TD $NW $AR> $F1 $data[13] $NB
<TD $NW $AR> $F1 $data[14] $NB
ENDOFFILE
   }

   }

$stmt->finish;

##-----------------------------------------------##
##  END OF REPORTS.             
##-----------------------------------------------##
 

print <<ENDOFFILE;
</TABLE>
</FORM>
<p>
$F1 Records: $i
</HTML>
ENDOFFILE

close(REPORT1);

##-----------------------------------------------##
##  END OF JOB.                 
##-----------------------------------------------##

require "audit_trail.pl";         ## Insert the Audit Trail
$RC = &insert_audit_trail;


$dbh->disconnect;   

exit;
