#!/usr/bin/perl
#print "Content-type: text/html\n\n";

use DBI;
use DBD::Oracle qw(:ora_types);

require "SYS_PROFILE";                     ## System Profile

require "$BINDIR/cgi-lib2.pl";             ## Perl Handling Sub-routines
require "$BINDIR/currency.pl";             ## Currency Format Sub-routine
require "$BINDIR/DEFAULT_FONTS";           ## Default Fonts 
require "$BINDIR/ORACLE_CONNECTION";       ## Oracle DB Connection Routine

if ($dbh eq '') { print "$FA Connection to Oracle Failed."; exit; }

require "$HOMEDIR/security_check.pl";      ## Check Security Access Level
$RC = &security_check;

if ($ACCESS ne 'A' && $ACCESS ne '!') {
    @proglist = ("security_violation.cgi");
    system(@proglist);
    exit;
  }

print "Content-type: text/html\n\n";

##-----------------------------------------------##
##  BEGINNING OF JOB.           
##-----------------------------------------------##

$SCRIPT = '05. maintain_security.cgi';

&ReadParse(*input);

#print $input;
#exit;

$input{'UID'} =~ tr/a-z/A-Z/;

##--------------------------##
## PRINT THE HEADER TABS
##--------------------------##
require "$BINDIR/HEADER_TABS";       ## Print out Header TABS.


print <<ENDOFFILE;
<TABLE bgcolor=$BC border=1 width=760>
<TR $VAM height=40>
<TD background=../images/CES-BACK.gif $AL $CS=6>
$NB $F1<b> SYSTEM ACCESS </TD>

<FORM ACTION=#JUMP METHOD="POST">
<TR bgcolor=$C1 height=35 $VAM>
<TD background=../images/CES-BACK.gif> $F1 
    <INPUT TYPE=TEXT NAME=UID SIZE=8 MAXLENGTH=8 value='$input{'ACCESS'}' STYLE=$FF1>
ENDOFFILE
   
print <<ENDOFFILE;
    <TD background=../images/CES-BACK.gif $CS=5 $NW>
    $F1<b> ACCESS LEVEL: 
    <SELECT NAME=SEC STYLE=$FF1>
    <OPTION VALUE='V:VIEW '>VIEW
    <OPTION VALUE='U:UPLOAD'>UPLOAD
    <OPTION VALUE='B:ACE-RECON'>ACE-RECON
    <OPTION VALUE='A:ADMIN'>ADMIN
ENDOFFILE

if ($ACCESS eq '!') { 
    print "<OPTION VALUE='!:IS-ADMIN'>IS-ADMIN ";
   }

print <<ENDOFFILE;
    </SELECT>
ENDOFFILE

$SEL1 = '';
if ($input{'ACCESS'} ne '') { $SEL1 = 'SELECTED'; }

print <<ENDOFFILE;
    $NB
    $F1<b> ACTION:
    <SELECT NAME=ACTN STYLE=$FF1>
    <OPTION VALUE=ADD>ADD USER
    <OPTION VALUE=ADD>UPDATE USER
    <OPTION VALUE=DEL $SEL1>DELETE USER
    <OPTION VALUE=RPT>LIST USERS 
    <OPTION VALUE=VAL>VALIDATE CALLUP 
    </SELECT>
ENDOFFILE


print <<ENDOFFILE;
    &nbsp; &nbsp;
    <INPUT TYPE=SUBMIT VALUE=RUN>
ENDOFFILE

#-----------------------------------------

if ($input{'ACTN'} eq 'DEL') {
print <<ENDOFFILE;
<TR bgcolor=$C1><TD $CS=6> $F1<b> $NB LDAPID: $NB $F1R<b> $input{'UID'} $NB $F2<b> WAS DELETED FROM THE DATABASE
ENDOFFILE
   }

$HREF1 = "<A HREF=maintain_security.cgi?&OBY=LDAP $HRN>$F1B<b>";
$HEND1 = "</A>";
$HREF2 = "<A HREF=maintain_security.cgi?&OBY=NAME $HRN>$F1B<b>";
$HEND2 = "</A>";

print <<ENDOFFILE;
<TR $AL bgcolor=$C1>
<TD width=75  $NW >$NB $F1<b> $HREF1 LDAPID $HEND1
<TD width=225 $NW >$NB $F1<b> $HREF2 NAME $HEND2
<TD $AL $NW >$NB $F1<b> ACCESS $NB
<TD $AC $NW >$NB $F1<b> UPDATED BY $NB
<TD $AC $NW >$NB $F1<b> DATE $NB
<TD $AC $NW >$NB $F1<b> TIME $NB
ENDOFFILE

if ($input{'OBY'} eq '') { $input{'OBY'} = 'LDAP'; }


$stmt = $dbh->prepare("
BEGIN genfin_dbo.pces_security.pces_security_rpt (:ldap, :actn, :seci, :secx, :user, :oby, :cursor );
END;
     ") or DBI::errstr;

($SECI, $SECX) = split(/:/,$input{'SEC'},2);

$stmt->bind_param(":ldap", $input{'UID'});
$stmt->bind_param(":actn", $input{'ACTN'});
$stmt->bind_param(":seci", $SECI);
$stmt->bind_param(":secx", $SECX);
$stmt->bind_param(":oby",  $input{'OBY'});
$stmt->bind_param(":user", $LOGON);

$stmt->bind_param_inout(":cursor", \$sth2, 0, { ora_type => ORA_RSET } );
$stmt->execute;

$i=0;
while ( @data = $sth2->fetchrow_array() ) {

$JUMP = '';
$JEND = '';
$ADD  = '';
if (substr($data[0].$SP,0,10) eq substr($input{'UID'}.$SP,0,10)) { 
    $JUMP = "<A NAME=JUMP>"; 
    $JEND = "</A>"; 
    $ADD  = $F1R; 
    }

$HREF0 = "<A HREF=maintain_security.cgi?&ACCESS=$data[0]>$F1B ";
$HEND0 = "</A>";

print <<ENDOFFILE;
<TR $AL BGCOLOR=$PC>
$JUMP $JEND
<TD $AL>$NB $F1 $ADD $data[0]
<TD $NW  $AL>$NB $F1 $ADD $data[1]
<TD $NW  $AL>$NB $F1 $HREF0 $data[3] $HEND0
<TD $NW  $AC>$NB $F1 $data[6]
<TD $NW  $AC>$NB $F1 $data[4] $NB
<TD $NW  $AC>$NB $F1 $data[5] $NB
ENDOFFILE

$i++;

} 


$stmt->finish;

print <<ENDOFFILE;
</SELECT></TD>

</table>

<p>
$F2 Users: $i
</font>
</body>
</HTML>
ENDOFFILE

$ENDDT = `date +%T`;
chop($ENDDT);

##---------------------------------------------------------------##
## INSERT THE AUDIT TRAIL.                                       ##
##---------------------------------------------------------------##

$input{'RPT'} = $input{'ACTN'};
if ($input{'ACTN'} eq '') { $input{'RPT'} = 'VIEW'; }

$PROF = $input{'UID'}.":".$input{'ACTN'}.":".$input{'SEC'};

require "$HOMEDIR/audit_trail.pl";         ## Insert the Audit Trail
$RC = &insert_audit_trail;



##-----------------------------------------------##
##  END OF JOB.                 
##-----------------------------------------------##

$dbh->disconnect;   

exit;
