#!/usr/bin/perl

use DBI;
use DBD::Oracle qw(:ora_types);

require "/home/j204sc/bin/cgi-lib2.pl";          ## Perl Handling Sub-routines
require "/home/j204sc/bin/currency.pl";          ## Currency Format Sub-routine
require "/home/j204sc/bin/DEFAULT_FONTS";        ## Default Fonts
require "/home/j204sc/bin/ORACLE_CONNECTION";    ## Oracle DB Connection Routine

if ($dbh eq '') { print "$FA Connection to Oracle Failed."; exit; }

#**************************************************************#
#                                                              #
#  Job j204_cb_gl.cgi will create the G/L JVs for the period   #
#                                                              #
#  Two Sections:                                               #
#     (1). G/L JVs.                                            #
#     (2). CIS Intercompany Entries                            #
#                                                              #
#**************************************************************#

$DATE1 = `date`;
chop $DATE1;

print <<ENDOFFILE;

**=====================================================**
** j204_cb_gl.cgi:  begin execution                    **
**=====================================================**
$DATE1

ENDOFFILE


###############
#  Section 1  #
###############

open(output1, ">/home/j204sc/output/t204_cb_gl.dat");


$stmt = $dbh->prepare("
BEGIN commbill_dbo.p204_cb_gl.p204_cb_gl_rpt ('G/L',' ', :cursor );
END;
     ") or DBI::errstr;

$stmt->bind_param_inout(":cursor", \$sth2, 0, { ora_type => ORA_RSET } );
$stmt->execute;

$i=0;
while ( @data = $sth2->fetchrow_array() ) {

if ($data[0] eq 'NULL') { $data[0] = ' '; }
if ($data[1] eq 'NULL') { $data[1] = ' '; }
if ($data[2] eq 'NULL') { $data[2] = ' '; }
if ($data[3] eq 'NULL') { $data[3] = ' '; }
if ($data[4] eq 'NULL') { $data[4] = ' '; }
if ($data[5] eq 'NULL') { $data[5] = ' '; }
if ($data[6] eq 'NULL') { $data[6] = ' '; }
if ($data[7] eq 'NULL') { $data[7] = ' '; }
if ($data[8] eq 'NULL') { $data[8] = ' '; }
if ($data[9] eq 'NULL') { $data[9] = ' '; }

#select f_fypd
#     , a_seq_n
#     , f_jv_n
#     , f_acct_x
#     , f_jvsrc_c
#     , f_jv_a
#     , f_jv_x
#  7  , f_jvent_d
#  8  , f_jv_d
#  9  , f_jv_t
# 10  , f_usrfld1_x

$PD1   = substr($data[0],4,2);
$FY1   = substr($data[0],0,4);

$OUT01 = substr('1'.$data[2].$SP,0,11);
$OUT02 = substr($data[3].$SP,0,20);
$OUT03 = substr($SP,0,15);
$OUT04 = substr($data[6].$SP,0,50);
$OUT05 = substr($data[4].$SP,0,13);
$OUT06 = $data[5];
$OUT06 =~ tr/.//;
$OUT07 = substr('C1CYA'.$PD1.$FY1.'9999    2'.$data[7].$SP,0,28);
$OUT08 = substr('  INFY'.$SP,0,28);
$OUT09 = substr($data[10].$SP,0,20);
$OUT10 = substr($SP,0,40);

printf (output1 "%s%s%s%s%s%15s%s%s%s%s%s%s%s%s%s%s%s \n",$OUT01,$OUT02,$OUT03,$OUT04,$OUT05,$OUT06,$OUT07,$OUT08,$OUT09,$OUT10);

$i = $i + 1;

  } 


$stmt->finish;

close(output1);

### END OF SECTION


###############
#  Section 2  #
###############

open(output2, ">/home/j204sc/output/t204_cb_cis.dat");

$sql_cmd = "
select substr(f_fypd,3,2)||'SC'||substr(f_acct_x,1,2)||substr(f_jv_n,1,2)
     , to_char(f_jv_a * -100, 999999000)
     , '990000Provider JV# '
     , substr(f_jv_n,1,8)||'1/User JV# '
     , f_jv_n
   from t204_cb_gl
where substr(f_acct_x,7,2) = 'SC'
and f_fypd = (select f_fypd from genfin_dbo.t740_fypd
               where to_char(sysdate + 4, 'YYYY/MM/DD')
                     between f_beg_d and f_end_d)
and f_jv_x = 'Interlocation'
            ";

$stmt = $dbh->prepare("
      $sql_cmd
     ") or DBI::errstr;

$stmt->execute;

print <<ENDOFFILE;
 $sql_cmd
ENDOFFILE

$i = 0;

while ( @data = $stmt->fetchrow_array() ) {

if ($data[0] eq 'NULL') { $data[0] = ' '; }
if ($data[1] eq 'NULL') { $data[1] = ' '; }
if ($data[2] eq 'NULL') { $data[2] = ' '; }
if ($data[3] eq 'NULL') { $data[3] = ' '; }
if ($data[4] eq 'NULL') { $data[4] = ' '; }

$data[0] = substr($data[0].$SP,0,8);
$data[2] = substr($data[2].$SP,0,19);
$data[3] = substr($data[3].$SP,0,19);
$data[4] = substr($data[4].$SP,0,22);

printf (output2 "%s%11s%s%s%s\n",$data[0],$data[1],$data[2],$data[3],$data[4]);

$i = $i + 1;

  }


$stmt->finish;

close(output2);

### END OF SECTION


$DATE1 = `date`;
chop $DATE1;

print <<ENDOFFILE;

Number of Records: $i  

*AIX*Successful exit -

**=====================================================**
** j204_cb_gl.cgi:  end execution                      **
**=====================================================**
$DATE1

ENDOFFILE

$dbh->disconnect;

exit;
