#!/usr/bin/perl

use DBI;

require "/home/j204sc/bin/cgi-lib2.pl";          ## Perl Handling Sub-routines
require "/home/j204sc/bin/currency.pl";          ## Currency Format Sub-routine
require "/home/j204sc/bin/DEFAULT_FONTS";        ## Default Fonts
require "/home/j204sc/bin/ORACLE_CONNECTION";    ## Oracle DB Connection Routine

if ($dbh eq '') { print "$FA Connection to Oracle Failed."; exit; }

#**************************************************************#
#                                                              #
#  Job j204_tb_rates.cgi will unload billing rates tables      #
#                                                              #
#  Four Sections:                                              #
#     (1). Table t204_tb_ac2 - Domestic Area Codes/Prefixes    #
#     (2). Table t204_tb_ac3 - Domestic Area Codes             #
#     (3). Table t204_tb_ac4 - International Codes             #
#     (4). Table t204_tb_st1 - State/Province Code Names       #
#                                                              #
#**************************************************************#

$DATE1 = `date`;
chop $DATE1;

print <<ENDOFFILE;

**=====================================================**
** j204_tb_rates.cgi:  begin execution                 **
**=====================================================**
$DATE1

ENDOFFILE


###############
#  Section 1  #
###############

open(output1, ">/home/j204sc/output/t204_tb_ac2.dat");

$sql_cmd = "
select f_aaa_c
     , f_ppp_c  
     , f_city_x  
     , f_st_c
     , f_rate1_a
     , f_rate2_a
     , db_upd_d
     , db_upd_x
  from t204_tb_ac2   
 order by f_aaa_c     
        , f_ppp_c   
           ";

$stmt = $dbh->prepare("
      $sql_cmd
     ") or DBI::errstr;

$stmt->execute;

print <<ENDOFFILE;
 $sql_cmd
ENDOFFILE

$SP = '                                                                   ';
$SC   = ':';
$TYP  = '2';

$i = 0;

$i=0;
while ( @data = $stmt->fetchrow_array() ) {

if ($data[0] eq 'NULL') { $data[0] = ' '; }
if ($data[1] eq 'NULL') { $data[1] = ' '; }
if ($data[2] eq 'NULL') { $data[2] = ' '; }
if ($data[3] eq 'NULL') { $data[3] = ' '; }
if ($data[4] eq 'NULL') { $data[4] = ' '; }
if ($data[5] eq 'NULL') { $data[5] = ' '; }
if ($data[6] eq 'NULL') { $data[6] = ' '; }
if ($data[7] eq 'NULL') { $data[7] = ' '; }
if ($data[8] eq 'NULL') { $data[8] = ' '; }
if ($data[9] eq 'NULL') { $data[9] = ' '; }

$data[0] = substr($data[0].$SP,0,3);
$data[1] = substr($data[1].$SP,0,3);
$data[2] = substr($data[2].$SP,0,10);
$data[3] = substr($data[3].$SP,0,2);

$data[6] = substr($data[6].$SP,0,10);
$data[7] = substr($data[7].$SP,0,10);

printf (output1 "%s %s %s %s %10s %10s %s %s \n",$data[0],$data[1],$data[2],$data[3],$data[4],$data[5],$data[6],$data[7]);

$i = $i + 1;

  } 


$stmt->finish;

close(output1);

### END OF SECTION


###############
#  Section 2  #
###############

open(output2, ">/home/j204sc/output/t204_tb_ac3.dat");

$sql_cmd = "
select f_aaa_c
     , f_st_c
     , f_rate1_a
     , f_rate2_a
     , db_upd_d
     , db_upd_x
  from t204_tb_ac3   
 order by f_aaa_c     
        , f_st_c   
            ";

$stmt = $dbh->prepare("
      $sql_cmd
     ") or DBI::errstr;

$stmt->execute;

print <<ENDOFFILE;
 $sql_cmd
ENDOFFILE

$SP = '                                                                   ';
$SC   = ':';
$TYP  = '2';

$i = 0;

while ( @data = $stmt->fetchrow_array() ) {

if ($data[0] eq 'NULL') { $data[0] = ' '; }
if ($data[1] eq 'NULL') { $data[1] = ' '; }
if ($data[2] eq 'NULL') { $data[2] = ' '; }
if ($data[3] eq 'NULL') { $data[3] = ' '; }
if ($data[4] eq 'NULL') { $data[4] = ' '; }
if ($data[5] eq 'NULL') { $data[5] = ' '; }
if ($data[6] eq 'NULL') { $data[6] = ' '; }
if ($data[7] eq 'NULL') { $data[7] = ' '; }
if ($data[8] eq 'NULL') { $data[8] = ' '; }
if ($data[9] eq 'NULL') { $data[9] = ' '; }

$data[0] = substr($data[0].$SP,0,3);
$data[1] = substr($data[1].$SP,0,2);

$data[4] = substr($data[4].$SP,0,10);
$data[5] = substr($data[5].$SP,0,10);

printf (output2 "%s %s %10s %10s %s %s  \n",$data[0],$data[1],$data[2],$data[3],$data[4],$data[5]);

$i = $i + 1;

  }


$stmt->finish;

close(output2);

### END OF SECTION


###############
#  Section 3  #
###############

open(output3, ">/home/j204sc/output/t204_tb_ac4.dat");

$sql_cmd = "
select f_aaa_c
     , f_ctry_x
     , f_rate1_a
     , f_rate2_a
     , db_upd_d
     , db_upd_x
  from t204_tb_ac4   
 order by f_aaa_c     
        , f_ctry_x
            ";

$stmt = $dbh->prepare("
     $sql_cmd
     ") or DBI::errstr;

$stmt->execute;

print <<ENDOFFILE;
 $sql_cmd
ENDOFFILE

$SP = '                                                                   ';
$SC   = ':';
$TYP  = '2';

$i = 0;

while ( @data = $stmt->fetchrow_array() ) {

if ($data[0] eq 'NULL') { $data[0] = ' '; }
if ($data[1] eq 'NULL') { $data[1] = ' '; }
if ($data[2] eq 'NULL') { $data[2] = ' '; }
if ($data[3] eq 'NULL') { $data[3] = ' '; }
if ($data[4] eq 'NULL') { $data[4] = ' '; }
if ($data[5] eq 'NULL') { $data[5] = ' '; }
if ($data[6] eq 'NULL') { $data[6] = ' '; }
if ($data[7] eq 'NULL') { $data[7] = ' '; }
if ($data[8] eq 'NULL') { $data[8] = ' '; }
if ($data[9] eq 'NULL') { $data[9] = ' '; }

$data[0] = substr($data[0].$SP,0,3);
$data[1] = substr($data[1].$SP,0,10);

$data[4] = substr($data[4].$SP,0,10);
$data[5] = substr($data[5].$SP,0,10);

printf (output3 "%s %s %10s %10s %s %s  \n",$data[0],$data[1],$data[2],$data[3],$data[4],$data[5]);

$i = $i + 1;

  }


$stmt->finish;

close(output3);

### END OF SECTION


###############
#  Section 4  #
###############

open(output4, ">/home/j204sc/output/t204_tb_st1.dat");

$sql_cmd = "
select f_st_c
     , f_st_x
     , db_upd_d
     , db_upd_x
  from t204_tb_st1   
 order by f_st_c     
            ";

$stmt = $dbh->prepare("
    $sql_cmd
     ") or DBI::errstr;

$stmt->execute;

print <<ENDOFFILE;
 $sql_cmd
ENDOFFILE

$SP = '                                                                   ';
$SC   = ':';
$TYP  = '2';

$i = 0;

while ( @data = $stmt->fetchrow_array() ) {

if ($data[0] eq 'NULL') { $data[0] = ' '; }
if ($data[1] eq 'NULL') { $data[1] = ' '; }
if ($data[2] eq 'NULL') { $data[2] = ' '; }
if ($data[3] eq 'NULL') { $data[3] = ' '; }
if ($data[4] eq 'NULL') { $data[4] = ' '; }
if ($data[5] eq 'NULL') { $data[5] = ' '; }
if ($data[6] eq 'NULL') { $data[6] = ' '; }
if ($data[7] eq 'NULL') { $data[7] = ' '; }
if ($data[8] eq 'NULL') { $data[8] = ' '; }
if ($data[9] eq 'NULL') { $data[9] = ' '; }

$data[0] = substr($data[0].$SP,0,2);
$data[1] = substr($data[1].$SP,0,50);
$data[2] = substr($data[2].$SP,0,10);
$data[3] = substr($data[3].$SP,0,10);

printf (output4 "%s %s %s %s \n",$data[0],$data[1],$data[2],$data[3]);

$i = $i + 1;

  }

$stmt->finish;

close(output4);

### END OF SECTION


$DATE1 = `date`;
chop $DATE1;

print <<ENDOFFILE;

Number of Records: $i  

*AIX*Successful exit -

**=====================================================**
** j204_tb_rates.cgi:  end execution                   **
**=====================================================**
$DATE1

ENDOFFILE

$dbh->disconnect;

exit;
