#!/usr/opt/perl5.00503/bin/perl5.00503
#print "Content-type: text/html\n\n";

use DBI;
use DBD::Oracle qw(:ora_types);

require "SYS_PROFILE";                     ## System Profile

require "$BINDIR/cgi-lib2.pl";             ## Perl Handling Sub-routines
require "$BINDIR/currency.pl";             ## Currency Format Sub-routine
require "$BINDIR/sp_parm_fmt.pl";          ## SP Input Format Sub-routine
require "$BINDIR/DEFAULT_FONTS";           ## Default Fonts 
require "$BINDIR/ORACLE_CONNECTION";       ## Oracle DB Connection Routine

if ($dbh eq '') { print "$FA Connection to Oracle Failed."; exit; }

require "$HOMEDIR/security_check.pl";      ## Check Security Access Level
$RC = &security_check;

#print "Content-type: text/html\n\n";
#print "\n RC:",$RC;
#print "\n LOGON:",$LOGON;
#print "\n ACCESS:",$ACCESS;
#print "\n NAME:",$NAME;
#print "\n ATITLE:",$ATITLE;
#exit;

if ($ACCESS ne 'A' && $ACCESS ne '!' && $ACCESS ne 'U') {
    @proglist = ("security_violation.cgi");
    system(@proglist);
    exit;
  }

print "Content-type: text/html\n\n";

##-----------------------------------------------##
##  BEGINNING OF JOB.           
##-----------------------------------------------##

$SCRIPT = 'bill_rpt_ldap2.cgi';

&ReadParse(*input);

#print $input;
#exit;

##-------------------------------------------------##
## SET UP OUTPUT FILE LINK                         ##
##-------------------------------------------------##

$UID =  substr($LOGON,0,6);
$UID =~ tr/ /0/;
$DX1 = substr($BEGDT,6,2);
$UID =  $UID."-".$DX1."rl2";

unlink ("/www/httpd/htdocs/nsr/REPORTS/$UID.XLS");
open(OUTPUT1, ">/www/httpd/htdocs/nsr/REPORTS/$UID.XLS");

printf (OUTPUT1 "%s \n","FYPD \t VENDOR \t  LDAPID \t BADGE \t NAME \t LOC \t DIV \t DEPT \t AMOUNT \t ADMIN \t TOTAL \t ");


##===================================================================##
## Create the Summary Report.                                        ##
##===================================================================##
    

print <<ENDOFFILE;
<HTML>
<head><title>Communication Billing Chargeouts   </title></head>
<BODY ALINK=#0000FF VLINK=#0000FF>
<TABLE border=1 cellpadding=0 cellspacing=0 width=100%>
<TR bgcolor=#3388EE><TD height=1> &nbsp; </TD>
</TABLE>
ENDOFFILE

print <<ENDOFFILE;
<TABLE border=0 cellpadding=2 cellspacing=2 width=700>
<TR>
<TD width=80> &nbsp;
<TD colspan=1 width=500 align=right><A HREF=../Comm-Billing style=text-decoration:none><FONT color=blue>$F0 Menu</A>
</TD>
<TD width=75 align=right><A HREF="/nsr/REPORTS/$UID.XLS" target=new><font color="#0000FF"><img src="../gifs/excel0.gif" border=0><font color=#000000><b>Excel</A></font></TD>
ENDOFFILE


##-------------------------------##
## Create the Billing Report     ##
##-------------------------------##

$sql_cmd = "
select f_fypd
     , f_vndr_c
     , a_uid_c
     , a_badge_n
     , a_uid_x
     , f_loc_c
     , f_div_c
     , f_dpt_c
     , to_char(f_txn_a, '999,990.00')
     , to_char(f_adm_a, '999,990.00')
     , to_char((f_txn_a + f_adm_a), '999,990.00')
  from commbill_dbo.t204_cb_ldap_charges  
 where f_vndr_c   like '$input{'VNDR'}'
   and f_fypd     like '$input{'FYPD'}'
 order by f_fypd 
        , f_vndr_c
        , a_uid_c
           ";

#print " SQL:",$sql_cmd;
#exit;

$stmt = $dbh->prepare("
      $sql_cmd
     ") or DBI::errstr;

$stmt->execute;


print <<ENDOFFILE;
<TR>
<TD colspan=3><hr noshade width=700>
<TR>
<TD width=80 align=right>$FA VENDOR:
<TD align=left>$FA $input{'VNDR'}
<TR>
<TD width=80 align=right>$FA FYPD: 
<TD align=left>$FA $input{'FYPD'}
</TABLE>
<pre><b>LDAPID BADGE    NAME                      LocDivDept    AMOUNT  ADMIN     TOTAL </b><pre>
ENDOFFILE

$AMT = 0;
$ADM = 0;
$TOT = 0;

$rows = 0;

while ( @data = $stmt->fetchrow_array() ) {

$rows = $rows + 1;

$AMT = $AMT + $data[8];
$ADM = $ADM + $data[9];
$TOT = $TOT + $data[10];

$data[8] = &curr($data[8],2); 
$data[9] = &curr($data[9],2); 
$data[10] = &curr($data[10],2); 

$data[4]   =~ tr/</ /;

$FYPD   = $input{'FYPD'};
$VNDR   = $input{'VNDR'};
$LDAP   = $data[2];
$LDAP   =~ tr/ /+/;
$VNDR   =~ tr/ /+/;
$HREF  = "<A HREF=bill_rpt_ldap3.cgi?&VNDR=$VNDR&LDAP=$LDAP&FYPD=$FYPD style=text-decoration:none><font color=blue>";
$HEND  = "</A><font color=black>";


$data[2] = substr($data[2].$SP,0,6);
$data[3] = substr($data[3].$SP,0,8);
$data[4] = substr($data[4].$SP,0,25);
$data[5] = substr($data[5].$SP,0,2);
$data[6] = substr($data[6].$SP,0,2);
$data[7] = substr($data[7].$SP,0,4);

printf ("%s%s%s %s %s %s %s %s %9s %6s %9s \n",$HREF,$data[2],$HEND,$data[3],$data[4],$data[5],$data[6],$data[7],$data[8],$data[9],$data[10]);

printf (OUTPUT1 "%s\t%s\t%s\t%s\t%s\t%s\t%s\t%s\t%s\t%s\t%s\t%s\t%s\t%s\t%s\t%s \n",$data[0],$data[1],$data[2],$data[3],$data[4],$data[5],$data[6],$data[7],$data[8],$data[9],$data[10],$data[11],$data[12],$data[13],$data[14],$data[15],$data[16],$data[17],$data[18],$data[19],$data[20]);

#print <<ENDOFFILE;
#<TR>
#<TD>$F1 $HREF $data[2] $HEND
#<TD align=left>$F1 $data[3]
#<TD nowrap align=left>$F1 $data[4]
#<TD nowrap align=left>$F1 $data[5]
#<TD nowrap align=left>$F1 $data[6]
#<TD align=left>$F1 $data[7]
#<TD align=left>$F1 $data[8]
#<TD align=right>$F1 $data[9]
#<TD align=right>$F1 $data[10]
#<TD align=right>$F1 $data[11]
#ENDOFFILE

   } 


$stmt->finish;

##===================================================================##


$AMT = &curr($AMT,2); 
$ADM = &curr($ADM,2); 
$TOT = &curr($TOT,2); 

#=============================================
print <<ENDOFFILE;
</pre>
<hr noshade>
TOTAL: Records: $rows    Amount: $AMT    Admin: $ADM    Chargeout: $TOT
<hr noshade>
</TABLE>
ENDOFFILE
#=============================================


close(OUTPUT1);

$ENDDT = `date +%T`;
chop($ENDDT);

##---------------------------------------------------------------##
## INSERT THE AUDIT TRAIL.                                       ##
##---------------------------------------------------------------##

$input{'RPT'} = $input{'ACTN'};
if ($input{'ACTN'} eq '') { $input{'RPT'} = 'VIEW'; }

$PROF = $input{'UID'}.":".$input{'ACTN'}.":".$input{'SEC'};

require "$HOMEDIR/audit_trail.pl";         ## Insert the Audit Trail
$RC = &insert_audit_trail;


$dbh->disconnect;   

exit;
