#!/usr/opt/perl5.00503/bin/perl5.00503
#print "Content-type: text/html\n\n";

use DBI;
use DBD::Oracle qw(:ora_types);

require "SYS_PROFILE";                     ## System Profile

require "$BINDIR/cgi-lib2.pl";             ## Perl Handling Sub-routines
require "$BINDIR/currency.pl";             ## Currency Format Sub-routine
require "$BINDIR/sp_parm_fmt.pl";          ## SP Input Format Sub-routine
require "$BINDIR/DEFAULT_FONTS";           ## Default Fonts 
require "$BINDIR/ORACLE_CONNECTION";       ## Oracle DB Connection Routine

if ($dbh eq '') { print "$FA Connection to Oracle Failed."; exit; }

require "$HOMEDIR/security_check.pl";      ## Check Security Access Level
$RC = &security_check;

#print "Content-type: text/html\n\n";
#print "\n RC:",$RC;
#print "\n LOGON:",$LOGON;
#print "\n ACCESS:",$ACCESS;
#print "\n NAME:",$NAME;
#print "\n ATITLE:",$ATITLE;
#exit;

if ($ACCESS ne 'A' && $ACCESS ne '!') {
    @proglist = ("security_violation.cgi");
    system(@proglist);
    exit;
  }

print "Content-type: text/html\n\n";

##-----------------------------------------------##
##  BEGINNING OF JOB.           
##-----------------------------------------------##

$SCRIPT = 'bill_save.cgi';

&ReadParse(*input);

#print $input;
#exit;

##===================================================================##

if ($input{'VENDOR'} eq "") {
   print "$FR Error: No VENDOR data type was Selected for Upload";
   exit;
   }

$VNDR = substr($input{'VENDOR'},0,10);
$TYPE = substr($input{'VENDOR'},11,10);
$FILE = substr($input{'VENDOR'},22,25);
$FILE =~ s/ //gi;

#print "<pre>VENDOR:",$VNDR,":";
#print "<pre>TYPE:",$TYPE,":";
#print "<pre>FILE:",$FILE,":";   

#=============================================
# Delete the Upload File.
#=============================================
#unlink("/home/commbill/public_html/COMMBILLING/$FILE");    
rename("/home/commbill/public_html/COMMBILLING/$FILE","/home/commbill/public_html/COMMBILLING/SAV.$FILE");    


#=================================================================##
# Save the Data to the Final Billing Charges table.
#=================================================================##


$PROC  = 'commbill_dbo.p204_bill_ool_sav.p204_bill_ool_sav_rpt';

if ($TYPE eq 'LDAPID    ') {
    $PROC  = 'commbill_dbo.p204_bill_ldap_sav.p204_bill_ldap_sav_rpt';
   }

# @vndr  = '$VNDR' 
# @fypd  = '$input{'FYPD'}'
# @type  = '$TYPE'
# $LOGON         = &sp_fmt($LOGON,8);

$stmt = $dbh->prepare("
BEGIN $PROC (:vndr, :fypd, :vcat, :cursor );
END;
     ") or DBI::errstr;

$stmt->bind_param(":fypd", $input{'FYPD'});
$stmt->bind_param(":vcat", $TYPE);
$stmt->bind_param(":vndr", $VNDR);

$stmt->bind_param_inout(":cursor", \$sth2, 0, { ora_type => ORA_RSET } );
$stmt->execute;

#print "<TR><TD><PRE>FYPD:",$input{'FYPD'};


$rows = 0;
$amt  = 0.00;
$adm  = 0.00;

print <<ENDOFFILE;
<HTML>
<head><title>Communication Billing Chargeouts   </title></head>
<BODY ALINK=#0000FF VLINK=#0000FF>
<TABLE border=1 cellpadding=0 cellspacing=0 width=100%>
<TR bgcolor=#3388EE><TD height=1> &nbsp; </TD>
</TABLE>
ENDOFFILE
    

print <<ENDOFFILE;
<TABLE border=0 cellspacing=1 cellpadding=0>
<TR>
<TD colspan=9 align=right><A HREF=../Comm-Billing style=text-decoration:none><FONT color=blue>$F0B Menu</A>
<TR><TD colspan=9><hr noshade>     
<TR>
<TD colspan=8>$F0<b> $input{'FYPD'} - $VNDR
<TR>
<TD>$F1<b> Cell Number
<TD>$F1<b> LDAPID
<TD>$F1<b> Badge
<TD>$F1<b> Name
<TD>$F1<b> Loc
<TD>$F1<b> Div
<TD>$F1<b> Dpt
<TD>$F1<b> Amount
<TD>$F1<b> Admin 
ENDOFFILE


while ( @data = $sth2->fetchrow_array() ) {

$rows = $rows + 1;

$amt = $amt + $data[9];
$adm = $adm + $data[10];

$data[9] = &curr($data[9],2);     
$data[10] = &curr($data[10],2);     

print <<ENDOFFILE;
<TR>
<TD>$F1 $HREF $data[2] $HEND  
<TD>$F1 $data[3]  &nbsp;
<TD>$F1 $data[4]  &nbsp;
<TD>$F1 $data[5]  
<TD>$F1 $data[6]  
<TD>$F1 $data[7]  
<TD>$F1 $data[8]  
<TD align=right>$F1 $data[9] 
<TD align=right>$F1 $data[10] 
ENDOFFILE

   } 

$stmt->finish;


#=============================================

$amt = &curr($amt,2);     
$adm = &curr($adm,2);     

print <<ENDOFFILE;
</TABLE>
<p>
<pre>
Number of Records: $rows    Amount:  $amt   Admin: $adm
</pre>
<hr noshade>
ENDOFFILE
#=============================================


$ENDDT = `date +%T`;
chop($ENDDT);

##---------------------------------------------------------------##
## INSERT THE AUDIT TRAIL.                                       ##
##---------------------------------------------------------------##

$input{'RPT'} = $input{'ACTN'};
if ($input{'ACTN'} eq '') { $input{'RPT'} = 'VIEW'; }

$PROF = $input{'UID'}.":".$input{'ACTN'}.":".$input{'SEC'};

require "$HOMEDIR/audit_trail.pl";         ## Insert the Audit Trail
$RC = &insert_audit_trail;


$dbh->disconnect;   

exit;
