#!/usr/opt/perl5.00503/bin/perl5.00503
#print "Content-type: text/html\n\n";

use DBI;
use DBD::Oracle qw(:ora_types);

require "SYS_PROFILE";                     ## System Profile

require "$BINDIR/cgi-lib2.pl";             ## Perl Handling Sub-routines
require "$BINDIR/currency.pl";             ## Currency Format Sub-routine
require "$BINDIR/sp_parm_fmt.pl";          ## SP Input Format Sub-routine
require "$BINDIR/DEFAULT_FONTS";           ## Default Fonts 
require "$BINDIR/ORACLE_CONNECTION";       ## Oracle DB Connection Routine

if ($dbh eq '') { print "$FA Connection to Oracle Failed."; exit; }

require "$HOMEDIR/security_check.pl";      ## Check Security Access Level
$RC = &security_check;

#print "Content-type: text/html\n\n";
#print "\n RC:",$RC;
#print "\n LOGON:",$LOGON;
#print "\n ACCESS:",$ACCESS;
#print "\n NAME:",$NAME;
#print "\n ATITLE:",$ATITLE;
#exit;

if ($ACCESS ne 'A' && $ACCESS ne '!') {
    @proglist = ("security_violation.cgi");
    system(@proglist);
    exit;
  }

print "Content-type: text/html\n\n";

##-----------------------------------------------##
##  BEGINNING OF JOB.           
##-----------------------------------------------##

$SCRIPT = 'bill_validate.cgi';

&ReadParse(*input);

#print $input;
#exit;

##===================================================================##

if ($input{'VENDOR'} eq "") {
   print "$FR Error: No VENDOR data type was Selected for Upload";
   exit;
   }


$VNDR = substr($input{'VENDOR'},0,10);
$TYPE = substr($input{'VENDOR'},11,10);
$FILE = substr($input{'VENDOR'},22,25);
$FILE =~ s/ //gi;

$PROC  = 'commbill_dbo.p204_bill_ool_val.p204_bill_ool_val_rpt';     

if ($TYPE eq 'LDAPID    ') { 
    $PROC  = 'commbill_dbo.p204_bill_ldap_val.p204_bill_ldap_val_rpt';     
   } 

#print "<pre>VENDOR:",$VNDR,":";
#print "<pre>TYPE:",$TYPE,":";
#print "<pre>FILE:",$FILE,":";
#print "<pre>PROC:",$PROC,":";

#=================================================================##
# Get the Exception Report. 
#=================================================================##

$input{'BADGE'} =~ tr/a-z/A-Z/;  

$input{'PHONE'} = &sp_fmt($input{'PHONE'},12);
$input{'BADGE'} = &sp_fmt($input{'BADGE'},10);
$VNDR           = &sp_fmt($VNDR,10);

if ($TYPE eq 'LDAPID    ') { 
    $input{'PHONE'} = &sp_fmt($input{'PHONE'},10);
   }

$stmt = $dbh->prepare("
BEGIN $PROC (:vndr, :phone, :badge, :cursor );
END;
     ") or DBI::errstr;

$stmt->bind_param(":vndr", $VNDR);
$stmt->bind_param(":phone", $input{'PHONE'});
$stmt->bind_param(":badge", $input{'BADGE'});

$stmt->bind_param_inout(":cursor", \$sth2, 0, { ora_type => ORA_RSET } );
$stmt->execute;

#print "<TR><TD><PRE>PROD:",$PROC;
#print "<TR><TD><PRE>VNDR:",$VNDR,":";
#print "<TR><TD><PRE>PHON:",$input{'PHONE'},":";
#print "<TR><TD><PRE>BADG:",$input{'BADGE'},":";


$rows = 0;
$amt  = 0.00;
 
$VNDR1  = $input{'VENDOR'};
$VNDR1  =~ tr/ /+/; 

print <<ENDOFFILE;
<HTML>
<head><title>Communication Billing Chargeouts   </title></head>
<BODY ALINK=#0000FF VLINK=#0000FF>
<TABLE border=1 cellpadding=0 cellspacing=0 width=100%>
<TR bgcolor=#3388EE><TD height=1> &nbsp; </TD>
</TABLE>
ENDOFFILE
    
print <<ENDOFFILE;
<TABLE border=0 cellspacing=1 cellpadding=0>
<TR>
<TD colspan=3><A HREF=ool_menu.cgi $HRN target=new><font color=blue> $F1B [Search Objects On Loan]</A></font>  
<TD colspan=2><A HREF=callup_menu.cgi $HRN target=new><font color=blue> $F1B [Search Callup]</A></font>  
<TD colspan=3 align=right><A HREF=../Comm-Billing $HRN><FONT color=blue>$F0B Menu</A>
<TR><TD colspan=8><hr noshade>
<TR>
<TD colspan=8 align=right><A HREF=bill_validate.cgi?&FYPD=$input{'FYPD'}&BADGE=ALL&VENDOR=$VNDR1 style=text-decoration:none><FONT color=blue>$F1B Show All Users</A>
<TR>
<TD colspan=8>$F0<b> $VNDR - $input{'FYPD'}
<TR>
<TD>$F1<b> Cell Nbr
<TD>$F1<b> LDAPID
<TD>$F1<b> Badge
<TD>$F1<b> Name
<TD>$F1<b> Loc
<TD>$F1<b> Div
<TD>$F1<b> Dpt
<TD>$F1<b> Amount
<TD>$F1<b> &nbsp;
ENDOFFILE

while ( @data = $sth2->fetchrow_array() ) {

$rows = $rows + 1;

$amt = $amt + $data[9];

$data[9] = &curr($data[9],2);     
#$data[9] = substr($data[9].$SP,0,15);     

$DATA2 = $data[2];
$DATA2 =~ tr/ /+/; 

$VNDR2  = $VNDR;      
$VNDR2  =~ tr/ /+/; 
$input{'VENDOR'}  =~ tr/ /+/; 

$HREF = "<A HREF=bill_valupd.cgi?&PHONE=$DATA2&VNDR=$VNDR2&VENDOR=$input{'VENDOR'} style=text-decoration:none><font color=blue>";
$HEND = "</A>";

print <<ENDOFFILE;
<TR>
<TD>$F1 $HREF $data[2] $HEND  
<TD>$F1 $data[3]  &nbsp;
<TD nowrap>$F1 $data[4]  &nbsp;
<TD nowrap>$F1 $data[5]  
<TD>$F1 $data[6]  
<TD>$F1 $data[7]  
<TD>$F1 $data[8]  
<TD align=right>$F1 $data[9] 
<TD nowrap>$F1R $data[10]  
ENDOFFILE

   } 

$stmt->finish;


#=============================================

$amt = &curr($amt,2);     

if ($rows eq 1 && $data[0] eq '') { $rows = $rows - 1; }
print <<ENDOFFILE;
</TABLE>
<p>
<pre>
Number of Exceptions: $rows    Amount:  $amt
</pre>
<hr>
ENDOFFILE
#=============================================


#=================================================================##
# Create the Summary Report.
#=================================================================##

$VNDR           = &sp_fmt($VNDR,10);

$stmt = $dbh->prepare("
BEGIN $PROC (:vndr, :phone, :badge, :cursor );
END;
     ") or DBI::errstr;

$stmt->bind_param(":vndr", $VNDR);
$stmt->bind_param(":phone", 'SUM');
$stmt->bind_param(":badge", '');

$stmt->bind_param_inout(":cursor", \$sth2, 0, { ora_type => ORA_RSET } );
$stmt->execute;

$rows = 0;

print <<ENDOFFILE;
<TABLE>
<TR>
<TD colspan=4>$F1<b> Total for Upload.
<TR>
<TD>$F1<b>FYPD     
<TD>$F1<b>VENDOR     
<TD>$F1<b>AMOUNT     
<TD>$F1<b>NBR of RECORDS
ENDOFFILE

while ( @data = $sth2->fetchrow_array() ) {

$rows = $rows + 1;

$data[9] = &curr($data[9],2);     
$data[10] = &curr($data[10],0);     

print <<ENDOFFILE;
</font>
<TR>
<TD>$F1 $data[0] 
<TD>$F1 $data[1] 
<TD align=right>$F1 $data[9] 
<TD align=right>$F1 $data[10] 
ENDOFFILE

   } 

$stmt->finish;

print <<ENDOFFILE;
</TABLE>
<hr>
ENDOFFILE


$ENDDT = `date +%T`;
chop($ENDDT);

##---------------------------------------------------------------##
## INSERT THE AUDIT TRAIL.                                       ##
##---------------------------------------------------------------##

$input{'RPT'} = $input{'ACTN'};
if ($input{'ACTN'} eq '') { $input{'RPT'} = 'VIEW'; }

$PROF = $input{'UID'}.":".$input{'ACTN'}.":".$input{'SEC'};

require "$HOMEDIR/audit_trail.pl";         ## Insert the Audit Trail
$RC = &insert_audit_trail;


$dbh->disconnect;   

exit;
