#!/usr/opt/perl5.00503/bin/perl5.00503
#print "Content-type: text/html\n\n";

use DBI;
use DBD::Oracle qw(:ora_types);

require "SYS_PROFILE";                     ## System Profile

require "$BINDIR/cgi-lib2.pl";             ## Perl Handling Sub-routines
require "$BINDIR/currency.pl";             ## Currency Format Sub-routine
require "$BINDIR/sp_parm_fmt.pl";          ## SP Input Format Sub-routine
require "$BINDIR/DEFAULT_FONTS";           ## Default Fonts
require "$BINDIR/ORACLE_CONNECTION";       ## Oracle DB Connection Routine

if ($dbh eq '') { print "$FA Connection to Oracle Failed."; exit; }

require "$HOMEDIR/security_check.pl";      ## Check Security Access Level
$RC = &security_check;

if ($ACCESS eq '') {
    @proglist = ("security_violation.cgi");
    system(@proglist);
    exit;
  }

print "Content-type: text/html\n\n";

##-----------------------------------------------##
##  BEGINNING OF JOB.           
##-----------------------------------------------##

$SCRIPT = 'oas_dbstats.cgi';

&ReadParse(*input);

#print $input;
#exit;

$box1    = "../../gifs/boxteal.gif";
$box2    = "../../gifs/boxyell.gif";

$WD  = 15;
$HT1 = 1797;
$HT2 = 1;
            
$OBY = '1 desc, 2, 3, 4';
if ($input{'SRT'} eq 'FYPD') { $OBY = '1 desc, 2, 3, 4'; }
if ($input{'SRT'} eq 'IND')  { $OBY = '2 desc, 1 desc, 3, 4'; }
if ($input{'SRT'} eq 'DESC') { $OBY = '4, 1 desc, 2, 3'; }

$CMD1 = " select f_fypd
               , ' '
               , ' '
               , ' '
               , sum(f_cnt1_a)
               , sum(f_cnt2_a)
               , sum(f_cnt3_a)
               , sum(f_cnt4_a)
               , sum(f_cnt5_a)
            from oas_dbo.t975_stats
           group by f_fypd
           order by $OBY 
        ";

$CMD2 = " select a.f_fypd
               , ' '
               , a.f_oas_c
               , b.f_oas_x
               , sum(f_cnt1_a)
               , sum(f_cnt2_a)
               , sum(f_cnt3_a)
               , sum(f_cnt4_a)
               , sum(f_cnt5_a)
            from oas_dbo.t975_stats a
               , oas_dbo.tf_oas_c   b
           where a.f_oas_c = b.f_oas_c(+)
           group by a.f_fypd
                  , a.f_oas_c 
                  , b.f_oas_x 
           order by $OBY
        ";

$CMD3 = " select a.f_fypd
               , a.f_oas_i
               , a.f_oas_c
               , b.f_oas_x
               , sum(f_cnt1_a)
               , sum(f_cnt2_a)
               , sum(f_cnt3_a)
               , sum(f_cnt4_a)
               , sum(f_cnt5_a)
            from oas_dbo.t975_stats a
               , oas_dbo.tf_oas_c   b
           where a.f_oas_c = b.f_oas_c(+)
           group by a.f_fypd
                  , a.f_oas_i 
                  , a.f_oas_c 
                  , b.f_oas_x 
           order by $OBY   
        ";

$CMD   = $CMD1;

if ($input{'RPT'} eq '') { $input{'RPT'} = 'SUM'; }

$HREF1 = "<A HREF=dbstats.cgi?&RPT=SUM $HRS> $F1B [Summary Report] </A>";
$HREF2 = "<A HREF=dbstats.cgi?&RPT=DET $HRS> $F1B [Detail Report] </A>";
$HREF3 = "<A HREF=dbstats.cgi?&RPT=FYP $HRS> $F1B [PTD/HST Report] </A>";
$HREF4 = "<A HREF=index.html> $F1B Menu </A> $NB";

if ($input{'RPT'} eq 'SUM') { $CMD = $CMD1; $HREF1 = "$F1B [Summary Report]"; }
if ($input{'RPT'} eq 'DET') { $CMD = $CMD2; $HREF2 = "$F1B [Detail Report]";  }
if ($input{'RPT'} eq 'FYP') { $CMD = $CMD3; $HREF3 = "$F1B [PTD/HST Report]"; ;  }

$stmt = $dbh->prepare("
BEGIN  OPEN :cursor FOR $CMD
        ;
END;
     ") or DBI::errstr;

$stmt->bind_param_inout(":cursor", \$sth2, 0, { ora_type => ORA_RSET } );
$stmt->execute;

$i=0;
while ( @data = $sth2->fetchrow_array() ) {

$data[4] = &curr($data[4],0);
$data[5] = &curr($data[5],0);
$data[6] = &curr($data[6],0);
$data[7] = &curr($data[7],0);
$data[8] = &curr($data[8],0);

##-----------------------------------------------##
##  Print the Headings.      
##-----------------------------------------------##
if ($i eq 0) {

$HREFD = "<A HREF=dbstats.cgi?&RPT=$input{'RPT'}&SRT=DESC $HRN>$F2B ";
$HENDD = "</A>";
$HREFI = "<A HREF=dbstats.cgi?&RPT=$input{'RPT'}&SRT=IND  $HRN>$F2B ";
$HENDI = "</A>";
$HREFF = "<A HREF=dbstats.cgi?&RPT=$input{'RPT'}&SRT=FYPD $HRN>$F2B ";
$HENDF = "</A>";

print <<ENDOFFILE;
<HTML>
<TITLE> OAS DATABASE STATISTICS $SERVER </TITLE>
<BODY bgcolor=$BC>
<TABLE border=1 bgcolor=$C1 $CPS1>
<TR $VAM>
<TD $AL $CS=9>$F0<b> Database Table Statistics  &nbsp;  $HREF1  &nbsp; $HREF2  &nbsp; $HREF3 $NB $NB $NB $HREF4
<TR>
<TD $AC>$F2 $HREFF FYPD $HENDF
<TD $AC>$F2 $HREFI IND  $HENDI  
<TD $AC>$F2 $HREFD TYPE $HENDD
<TD $AC>$F2 $HREFD DESCRIPTION $HENDD
<TD $AC>$F2 T280_OAS_SUM
<TD $AC>$F2 T280_OAS_DEV
<TD $AC>$F2 T280_OAS_LOT
<TD $AC>$F2 T280_NCAS_SCRAP
<TD $AC>$F2 T280_OAS_RANK
</TR>
ENDOFFILE
   }
   
$DATA2 = $data[2];
if (substr($data[2],0,1) eq '~') { $DATA2 = $data[3]; }



if ($data[0] ne '0') {
print <<ENDOFFILE;
<TR bgcolor=$C2>
<TD $AL >$F2 $data[0]       </TD>
<TD $AC >$F2 $data[1] &nbsp;</TD>
<TD $AL >$F2 $data[2] &nbsp;</TD>
<TD $AL >$F2 $data[3] &nbsp;</TD>
<TD $AR >$F2 $data[4]       </TD>
<TD $AR >$F2 $data[5]       </TD>
<TD $AR >$F2 $data[6]       </TD>
<TD $AR >$F2 $data[7]       </TD>
<TD $AR >$F2 $data[8]       </TD>
ENDOFFILE
   }

$i++;

} 

$stmt->finish;


##-----------------------------------------------##
##  END OF REPORT.              
##-----------------------------------------------##

ENDIT:

$ENDDT = `date +%T`;
chop($ENDDT);

print <<ENDOFFILE;
<TR bgcolor=$C1><TD $CS=9>$F2 NUMBER OF RECORDS: $i
</TABLE> 
<P> 
<pre>
<font face=arial size=-1>Beg:$BEGDT
<font face=arial size=-1>End:$ENDDT
</pre>
</FORM>
</BODY>
</HTML>
ENDOFFILE

##-----------------------------------------------##
##  END OF JOB.                 
##-----------------------------------------------##

$dbh->disconnect;   

exit;
