#!/usr/opt/perl5.00503/bin/perl5.00503
#print "Content-type: text/html\n\n";

use DBI;
use DBD::Oracle qw(:ora_types);

require "SYS_PROFILE";                     ## System Profile

require "$BINDIR/cgi-lib2.pl";             ## Perl Handling Sub-routines
require "$BINDIR/currency.pl";             ## Currency Format Sub-routine
require "$BINDIR/sp_parm_fmt.pl";          ## SP Input Format Sub-routine
require "$BINDIR/DEFAULT_FONTS";           ## Default Fonts 
require "$BINDIR/ORACLE_CONNECTION";       ## Oracle DB Connection Routine

if ($dbh eq '') { print "$F0<b> Connection to Oracle Failed."; exit; }

require "$HOMEDIR/security_check.pl";      ## Check Security Access Level
$RC = &security_check;

#print "Content-type: text/html\n\n";
#print "\n RC:",$RC;
#print "\n LOGON:",$LOGON;
#print "\n ACCESS:",$ACCESS;
#print "\n NAME:",$NAME;
#print "\n ATITLE:",$ATITLE;
#exit;

if ($ACCESS ne 'A' && $ACCESS ne '!') {
    @proglist = ("security_violation.cgi");
    system(@proglist);
    exit;
  }

print "Content-type: text/html\n\n";

##-----------------------------------------------##
##  BEGINNING OF JOB.           
##-----------------------------------------------##

$SCRIPT = 'bill_delete.cgi';

&ReadParse(*input);

#print $input;
#exit;

##===================================================================##

if ($input{'VENDOR'} eq "") {
   print "$F0R<b> Error: No VENDOR data type was Selected for Upload";
   exit;
   }

if ($input{'TYPE'} eq "") {
   $TYPE = 'RPT';
   $RPT  = 'RPT';
   }
else {
   $RPT = 'DEL';
   }

$VNDR = substr($input{'VENDOR'}.$SP,0,10);
$TYPE = substr($input{'VENDOR'}.$SP,11,10);

if ($TYPE eq "          ") {
   $TYPE = substr($input{'VTYPE'}.$SP,0,10);
   }

$PROC  = 'commbill_dbo.p204_bill_ool_del.p204_bill_ool_del_rpt';

if ($TYPE eq 'LDAPID    ') {
    $PROC  = 'commbill_dbo.p204_bill_ldap_del.p204_bill_ldap_del_rpt';
   }

# @vndr  = '$VNDR'
# @fypd  = '$input{'FYPD'}'
# @type  = '$TYPE'
# $LOGON         = &sp_fmt($LOGON,8);

$stmt = $dbh->prepare("
BEGIN $PROC (:vndr, :fypd, :vcat, :rpt, :cursor );
END;
     ") or DBI::errstr;

$stmt->bind_param(":vndr", $VNDR);
$stmt->bind_param(":fypd", $input{'FYPD'});
$stmt->bind_param(":vcat", $TYPE);
$stmt->bind_param(":rpt",  $RPT);

$stmt->bind_param_inout(":cursor", \$sth2, 0, { ora_type => ORA_RSET } );
$stmt->execute;
 
#print "<TR><TD><PRE>VNDR:",$VNDR,":";
#print "<TR><TD><PRE>FYPD:",$input{'FYPD'},":";
#print "<TR><TD><PRE>TYPE:",$TYPE,":";
#print "<TR><TD><PRE>RPT:",$RPT,":";

print <<ENDOFFILE;
<HTML>
<head><title>Communication Billing Chargeouts   </title></head>
<BODY ALINK=#0000FF VLINK=#0000FF>
<TABLE border=1 cellpadding=0 cellspacing=0 width=100%>
<TR bgcolor=#3388EE><TD height=1> &nbsp; </TD>
</TABLE>
ENDOFFILE

print <<ENDOFFILE;
<TABLE border=0 cellpadding=2 cellspacing=2>
<TR>
<TD colspan=8 align=right><A HREF=../Comm-Billing style=text-decoration:none><FONT color=blue>$F0B Menu</A>  
<TR><TD colspan=8><hr noshade>     
<TR>
<TD colspan=2>$F0<b> FYPD: $input{'FYPD'}
<TR>
<TD>$F0<b> Vendor
<TD>$F0<b> Amount Uploaded
<TD>$F0<b> Admin Charge
<TD>$F0<b> Amount Charged Out
<TD>$F0<b> Nbr of Records
ENDOFFILE


$rows = 0;

while ( @data = $sth2->fetchrow_array() ) {

$rows = $rows + 1;

$data[2] = &curr($data[2],2);
$data[3] = &curr($data[3],2);
$data[4] = &curr($data[4],2);
$data[5] = &curr($data[5],0);

print <<ENDOFFILE;
<TR>
<TD>$F1 $data[1]
<TD align=right>$F1 $data[2]
<TD align=right>$F1 $data[3]
<TD align=right>$F1 $data[4]
<TD align=right>$F1 $data[5]
ENDOFFILE

   } 

$stmt->finish;


##===================================================================##


#=============================================
print <<ENDOFFILE;
</TABLE>
<P>$F1 Number of Records: $rows
ENDOFFILE
#=============================================

if ($input{'TYPE'} eq 'DEL') {
   print "<P>$F0R<b> Records were Deleted";
   print "</b>$F0 <FORM ACTION=../Comm-Billing><INPUT TYPE=SUBMIT VALUE=Menu></FORM>";
   print "<hr noshade>";
   exit;
   }

$VENDOR = $VNDR;

print <<ENDOFFILE;
<TABLE border=0 cellspacing=3 cellpadding=3>
<FORM ACTION=bill_delete.cgi>
<TR>
<TD colspan=3>$F0R<b> Confirm Delete of:   
<TR>
<TD>$F0<b> Vendor
<TD>$F0<b> FYPD
<TD>$F0<b> &nbsp;
<TR>
<TD><INPUT TYPE=HIDDEN NAME=VENDOR VALUE=$VENDOR>$F0R<b> $VNDR
    <INPUT TYPE=HIDDEN NAME=VTYPE  VALUE=$TYPE>
<TD><INPUT TYPE=HIDDEN NAME=FYPD   VALUE=$input{'FYPD'}>$F0R<b> $input{'FYPD'}
<TD><INPUT TYPE=SUBMIT VALUE=Delete>
    <INPUT TYPE=HIDDEN NAME=TYPE VALUE=DEL>
</TABLE>
<hr noshade>
ENDOFFILE


$ENDDT = `date +%T`;
chop($ENDDT);

##---------------------------------------------------------------##
## INSERT THE AUDIT TRAIL.                                       ##
##---------------------------------------------------------------##

$input{'RPT'} = $input{'ACTN'};
if ($input{'ACTN'} eq '') { $input{'RPT'} = 'VIEW'; }

$PROF = $input{'UID'}.":".$input{'ACTN'}.":".$input{'SEC'};

require "$HOMEDIR/audit_trail.pl";         ## Insert the Audit Trail
$RC = &insert_audit_trail;


$dbh->disconnect;   

exit;
