#!/usr/opt/perl5.00503/bin/perl5.00503
#print "Content-type: text/html\n\n";

use DBI;
use DBD::Oracle qw(:ora_types);

require "SYS_PROFILE";                     ## System Profile

require "$BINDIR/cgi-lib2.pl";             ## Perl Handling Sub-routines
require "$BINDIR/currency.pl";             ## Currency Format Sub-routine
require "$BINDIR/sp_parm_fmt.pl";          ## SP Input Format Sub-routine
require "$BINDIR/DEFAULT_FONTS";           ## Default Fonts
require "$BINDIR/ORACLE_CONNECTION";       ## Oracle DB Connection Routine

if ($dbh eq '') { print "$FA Connection to Oracle Failed."; exit; }

require "$HOMEDIR/security_check.pl";      ## Check Security Access Level
$RC = &security_check;

if ($ACCESS eq '') {
    @proglist = ("security_violation.cgi");
    system(@proglist);
    exit;
  }

print "Content-type: text/html\n\n";

##-----------------------------------------------##
##  BEGINNING OF JOB.           
##-----------------------------------------------##

$SCRIPT = 'custom_rpt.cgi';

&ReadParse(*input);

#print $input;
#exit;

$TEXT = "NO";

$input{'NSID'} =~ tr/a-z/A-Z/;                
$input{'SPEC'} =~ tr/a-z/A-Z/;                
$input{'ACCT'} =~ tr/a-z/A-Z/;                

$NSID = $input{'NSID'}; 
$SPEC = $input{'SPEC'};
$ACCT = $input{'ACCT'};
$TYP  = $input{'TYP'};
if ($input{'TYP'} eq "%") {
    $TYP = 'ALL';            
   }                          
if ($input{'TYP'} eq "F") {
    $TYP = 'FGDS';            
   }                          
if ($input{'TYP'} eq "D") {
    $TYP = 'DIE';            
   }                          
$DIV  = $input{'DIV'};
if ($input{'DIV'} eq "%%") {
    $DIV = 'ALL';            
   }                          

$input{'NSID'} =~ tr/*/%/;
$input{'SPEC'} =~ tr/*/%/;
$input{'ACCT'} =~ tr/*/%/;

if ($input{'NSID'} eq 'ALL') { $input{'NSID'} = '%'; }
if ($input{'SPEC'} eq 'ALL') { $input{'SPEC'} = '%'; }
if ($input{'ACCT'} eq 'ALL') { $input{'ACCT'} = '%'; }

if (substr($input{'NSID'}."   ",0,3) eq 'ALL') { $input{'NSID'} = '%';}
if (substr($input{'SPEC'}."   ",0,3) eq 'ALL') { $input{'SPEC'} = '%';}
if (substr($input{'ACCT'}."   ",0,3) eq 'ALL') { $input{'ACCT'} = '%';}
if (substr($input{'GRP'}."   ",0,3) eq 'ALL') { $input{'GRP'} = '%'; } 
if (substr($input{'DVN'}."   ",0,3) eq 'ALL') { $input{'DVN'} = '%'; } 
if (substr($input{'BUS'}."   ",0,3) eq 'ALL') { $input{'BUS'} = '%'; } 
if (substr($input{'AFM'}."   ",0,3) eq 'ALL') { $input{'AFM'} = '%'; }
if (substr($input{'MKT'}."   ",0,3) eq 'ALL') { $input{'MKT'} = '%'; } 

if (substr($input{'NSID'}."   ",0,3) eq '   ') { $input{'NSID'} = '%';}
if (substr($input{'SPEC'}."   ",0,3) eq '   ') { $input{'SPEC'} = '%';}
if (substr($input{'ACCT'}."   ",0,3) eq '   ') { $input{'ACCT'} = '%';}
if (substr($input{'GRP'}."   ",0,3) eq '   ') { $input{'GRP'} = '%'; }
if (substr($input{'DVN'}."   ",0,3) eq '   ') { $input{'DVN'} = '%'; }
if (substr($input{'BUS'}."   ",0,3) eq '   ') { $input{'BUS'} = '%'; }
if (substr($input{'AFM'}."   ",0,3) eq '   ') { $input{'AFM'} = '%'; } 

$FAM = 'ALL';
$ORG = 'NO';

if ($input{'AFM'} ne "%%") {
    $input{'BUS'} = '%';
    $input{'DVN'} = '%';
    $input{'GRP'} = '%';
    $FAM = $input{'AFM'};
   }

if ($input{'BUS'} ne "%") {
    $input{'DVN'} = '%';
    $input{'GRP'} = '%';
    $FAM = $input{'BUS'};
    $ORG = 'YES';
   }

if ($input{'DVN'} ne "%") {
    $input{'GRP'} = '%';
    $FAM = $input{'DVN'};
    $ORG = 'YES';
   }

if ($input{'GRP'} ne "%") {
    $FAM = $input{'GRP'};
    $ORG = 'YES';
   }                          

##-----------------------------------------------##
##  Set up Output File Link.
##-----------------------------------------------##

$UID   = $ENV{'REMOTE_USER'};
$DT1   = `date +%T`;
$UID1  = $UID.substr($DT1,6,2)."-CP";
$UID1  =~ tr/a-z/A-Z/;
$UID1  =~ s/ /0/gi;

unlink ("../../REPORTS/$UID1.TXT");
unlink ("../../REPORTS/$UID1.XLS");
open(REPORT1, ">../../REPORTS/$UID1.TXT");
open(REPORT2, ">../../REPORTS/$UID1.XLS");

##-----------------------------------------------##
##  Print the Headings.      
##-----------------------------------------------##

print <<ENDOFFILE;
<HTML>
<HEAD>
<TITLE>OAS Custom Part Lookup $SERVER </TITLE></HEAD>
<BODY BACKGROUND=$BG BGCOLOR=$BC TEXT=$TC>

<LEFT>
<TABLE width=500 bgcolor=$BC border=0>
<TR $VAB>
<TD><A HREF="../../REPORTS/$UID1.TXT"><font color=$BC><img src="../../IMAGES/triangle.gif" border=0>$F1B <b>.TXT</A>
<TD><A HREF="../../REPORTS/$UID1.XLS"><font color=$BC><img src="../../IMAGES/excel0.gif" border=0>$F1B <b>Excel</A>
<TD $AL $CS=4>$FA RESERVES - $FA Custom Part Report </TD>
</TABLE>
<P>
<TABLE width=500 bgcolor=$C1 border=1>
<TR bgcolor=$C1>
<TD $CS=6>$F2
NSID: $NSID  &nbsp; SPEC: $SPEC  &nbsp;  ACCTCD: $ACCT &nbsp; TYPE: $TYP &nbsp; DIV: $DIV 
<br>ORG: $FAM
</TD>

<TR bgcolor=$C1>
<TD $AC>$F1 NSID
<TD $AC>$F1 SPEC
<TD $AC>$F1 ACCTCD
<TD $AC>$F1 DIV
<TD $AC>$F1 Custom
<TD $AC>$F1<A HREF=../../IAS/cgi-bin/helpmkt.cgi style=text-decoration:none><font color=blue><b>Mkt Code </A>
ENDOFFILE

printf (REPORT1 "NSID            SPEC     ACCTCD DIV RSV MKT   \n");
printf (REPORT2 "NSID \t SPEC \t ACCTCD \t DIV \t RSV \t MKT \t \n");
 
 $input{'NSID'} = &sp_fmt($input{'NSID'},15);
 $input{'SPEC'} = &sp_fmt($input{'SPEC'},8);
 $input{'ACCT'} = &sp_fmt($input{'ACCT'},6);
 $input{'AFM'}  = &sp_fmt($input{'AFM'},2);

$input{'AFM'} = substr($input{'AFM'}.$SP,0,2);

$stmt = $dbh->prepare("
BEGIN oas_dbo.p975_custom.p975_custom_rpt(:nsid, :spec, :afm, :typ, :grp, :dvn, :bus, :acct, :div, :cust, :mkt, :org, :ldap, :cursor);
END;
     ") or DBI::errstr;

$stmt->bind_param(":nsid", $input{'NSID'});
$stmt->bind_param(":spec", $input{'SPEC'});
$stmt->bind_param(":afm",  $input{'AFM'});
$stmt->bind_param(":typ",  $input{'TYP'});
$stmt->bind_param(":grp",  $input{'GRP'});
$stmt->bind_param(":dvn",  $input{'DVN'});
$stmt->bind_param(":bus",  $input{'BUS'});
$stmt->bind_param(":acct", $input{'ACCT'});
$stmt->bind_param(":div",  $input{'DIV'});
$stmt->bind_param(":cust", $input{'CUST'});
$stmt->bind_param(":mkt",  $input{'MKT'});
$stmt->bind_param(":org",  $ORG);
$stmt->bind_param(":ldap", $LOGON);

$stmt->bind_param_inout(":cursor", \$sth2, 0, { ora_type => ORA_RSET } );
$stmt->execute;

$i=0;
while ( @data = $sth2->fetchrow_array() ) {

$data[0] = substr($data[0]."               ",0,15);
$data[1] = substr($data[1]."        ",0,8);
$data[2] = substr($data[2]."      ",0,6);
$data[3] = substr($data[3]."  ",0,2);

printf (REPORT1 "%15s %8s %6s %2s %3s %3s  \n",$data[0],$data[1],$data[2],$data[3],$data[4],$data[5]);
printf (REPORT2 "%s\t%s\t%s\t%s\t%s\t%s\t \n",$data[0],$data[1],$data[2],$data[3],$data[4],$data[5]);

##---------------------------------------------------------------##
## IF ROWLIMIT EXCEEDED END THE TABLE.                           ##
##---------------------------------------------------------------##
if ($i eq 1000) {
   print "<TR bgcolor=$C2><td colspan=6>";
   print "<pre>";
   print " \n";
   print "$FBR FORMAT LIMIT EXCEEDED.";
   print "<pre>";
   print "$F0 converting to text report....";
   print "$FTX";
   print "<pre>";
   print " \n";
   $TEXT = "YES";
   }

##---------------------------------------------------------------##
## IF ROWLIMIT EXCEEDED PRINT TEXT REPORT, ELSE TABLE REPORT.    ##
##---------------------------------------------------------------##
if ($TEXT eq "YES") {            
   printf ("%6s %15s %8s %2s %3s %3s \n",$data[0],$data[1],$data[2],$data[3],$data[4],$data[5]);
   }
else {

print <<ENDOFFILE;
<TR bgcolor=$C2>
<TD $AL>$F2$data[0] &nbsp;
<TD $AL>$F2$data[1] &nbsp; 
<TD $AL>$F2$data[2] &nbsp;
<TD $AC>$F2$data[3] &nbsp;
<TD $AC>$F2$data[4] &nbsp;
<TD $AC>$F2$data[5] &nbsp;
ENDOFFILE

 }
##---------------------------------------------------------------##
## END OF ROW LIMIT EXCEEDED BRACKET.                            ##
##---------------------------------------------------------------##

$i++;

} 

$stmt->finish;


##-----------------------------------------------##
##  END OF REPORT.              
##-----------------------------------------------##

$ENDDT = `date +%T`;
chop($ENDDT);

print <<ENDOFFILE;
</TABLE>
<pre>
$F1 Nbr of Records: $i

$F1 Beg:$BEGDT
$F1 End:$ENDDT
</pre>

</HTML>
ENDOFFILE

close(REPORT1);                      
close(REPORT2);                      

print <<ENDOFFILE;
</font>
</body>
</HTML>
ENDOFFILE

##---------------------------------------------------------------##
## INSERT THE AUDIT TRAIL.                                       ##
##---------------------------------------------------------------##

$PROF = $input{'NBKL'}.$input{'N060'}.$input{'N090'}.$input{'N120'}.$input{'N150'}.$input{'N180'}.$input{'N270'}.$input{'N365'}.$input{'N999'};

require "$HOMEDIR/audit_trail.pl";         ## Insert the Audit Trail
$RC = &insert_audit_trail;


##-----------------------------------------------##
##  END OF JOB.                 
##-----------------------------------------------##

$dbh->disconnect;   

exit;
