#!/usr/opt/perl5.00503/bin/perl5.00503
#print "Content-type: text/html\n\n";

use DBI;
use DBD::Oracle qw(:ora_types);

require "SYS_PROFILE";                     ## System Profile

require "$BINDIR/cgi-lib2.pl";             ## Perl Handling Sub-routines
require "$BINDIR/currency.pl";             ## Currency Format Sub-routine
require "$BINDIR/sp_parm_fmt.pl";          ## SP Input Format Sub-routine
require "$BINDIR/DEFAULT_FONTS";           ## Default Fonts
require "$BINDIR/ORACLE_CONNECTION";       ## Oracle DB Connection Routine

if ($dbh eq '') { print "$FA Connection to Oracle Failed."; exit; }

require "$HOMEDIR/security_check.pl";      ## Check Security Access Level
$RC = &security_check;


if ($ACCESS eq '') {
    @proglist = ("security_violation.cgi");
    system(@proglist);
    exit;
  }

print "Content-type: text/html\n\n";

##-----------------------------------------------##
##  BEGINNING OF JOB.           
##-----------------------------------------------##

$SCRIPT = 'oas_dbspace.cgi';

&ReadParse(*input);

#print $input;
#exit;

$box1    = "../../gifs/boxblue.gif";
$box2    = "../../gifs/boxyell.gif";

$WD  = 15;
$HT1 = 1797;
$HT2 = 1;

$OBY = "3, 1, 2, 4";
if ($input{'SRT'} eq 'SEG') { $OBY = "1, 3, 2, 4"; }
if ($input{'SRT'} eq 'NBR') { $OBY = "1, 5 desc, 3"; }
if ($input{'SRT'} eq 'DAT') { $OBY = "1, 6 desc, 3"; }
if ($input{'SRT'} eq 'INX') { $OBY = "1, 7 desc, 3"; }

$stmt = $dbh->prepare("
BEGIN  OPEN :cursor FOR 
    select f_srt_c
         , f_dbo_x
	 , f_tbname_x
	 , f_segname_x
	 , sum(f_count_n)
	 , sum(f_bytes_a)
	 , sum(f_index_a)
	 , sum(f_extents_a)
	 , sum(f_used_p)
      from oas_dbo.t975_dbspace
     group by  f_srt_c
         , f_dbo_x
	 , f_tbname_x
	 , f_segname_x
    order by $OBY
        ;
END;
     ") or DBI::errstr;

$stmt->bind_param_inout(":cursor", \$sth2, 0, { ora_type => ORA_RSET } );
$stmt->execute;

$i=0;
while ( @data = $sth2->fetchrow_array() ) {

$data[4] = &curr($data[4],0);
$data[5] = &curr($data[5],0);
$data[6] = &curr($data[6],0);
$data[7] = &curr($data[7],0);

##-----------------------------------------------##
##  Print the Headings.      
##-----------------------------------------------##
if ($i eq 0) {

$HT1 = $HT1 = 470;  
$HT2 = ($HT1 * $data[8]) / 100;
$HT3 = $data[8];


#print "<BR> HT1:",$HT1;
#print "<BR> HT2:",$HT2;
#print "<BR> HT3:",$HT3;

print <<ENDOFFILE;
<HTML>
<TITLE> OAS DATABASE SPACE STATISTICS $SERVER </TITLE>
<BODY bgcolor=$BC>
<TABLE border=1 bgcolor=$C1 $CPS1 width=550>
<TR>
<TD $AR $CS=2><A HREF=index.html> $F1B Menu </A> $NB
<TR $VAM>
<TD> $F1<b> DB Space:
<TD><img src="$box1 " width=$HT1 height=$WD>
<TR valign=middle>
<TD> $F1<b> Pct Used:
<TD><img src="$box2 " width=$HT2 height=$WD> $F0<b> &nbsp; $HT3 &#37; 
</TABLE>
ENDOFFILE

$HREFS = "<A HREF=dbspace.cgi?&SRT=SEG  $HRN>$F1B ";
$HENDS = "</A>";
$HREFN = "<A HREF=dbspace.cgi?&SRT=NBR  $HRN>$F1B ";
$HENDN = "</A>";
$HREFD = "<A HREF=dbspace.cgi?&SRT=DAT  $HRN>$F1B ";
$HENDD = "</A>";
$HREFI = "<A HREF=dbspace.cgi?&SRT=INX  $HRN>$F1B ";
$HENDI = "</A>";

print <<ENDOFFILE;
<p>
<TABLE width=550 bgcolor=$C1 border=1>
<TR>
<TD $AL $CS=2>$F0<b> Database: OAS1 
<TD $AC $CS=3>$F1<b> Size: $data[7] (KB) &nbsp; &nbsp; Used: $data[5] (KB)
<b>
<TR $AL >
<TD $CS=1>$F1 OWNER 
<TD $CS=1>$F1 $HREFS  SEGMENT NAME $HENDS
<TD $AR  >$F1 $HREFN  Nbr of Rows  $HENDN
<TD $AR  >$F1 $HREFD  DATA (KB)    $HENDD
<TD $AR  >$F1 $HREFI  INDEXES (KB) $HENDI
</b>
</TR>
ENDOFFILE
   }
   
$DATA2 = $data[2];
if (substr($data[2],0,1) eq '~') { $DATA2 = $data[3]; }

$HREF = "<A HREF=dbtable.cgi?&TBNAME=$DATA2 style=text-decoration:none><font color=black>";
$HEND = "</A>";

if ($data[0] ne '0') {
print <<ENDOFFILE;
<TR bgcolor=$C2>
<TD $AL >$F2 $HREF $data[1] $HEND </TD>
<TD $AL >$F2 $HREF $data[3] $HEND </TD>
<TD $AR width=100>$F2 $data[4]       </TD>
<TD $AR width=100>$F2 $data[5]       </TD>
<TD $AR width=100>$F2 $data[6]       </TD>
ENDOFFILE
   }

$i++;

} 

$stmt->finish;


##-----------------------------------------------##
##  END OF REPORT.              
##-----------------------------------------------##

ENDIT:

$ENDDT = `date +%T`;
chop($ENDDT);

print <<ENDOFFILE;
<TR bgcolor=$C1><TD $CS=5>$F2 NUMBER OF TABLES: $i
</TABLE> 
<P> 
<pre>
<font face=arial size=-1>Beg:$BEGDT
<font face=arial size=-1>End:$ENDDT
</pre>
</FORM>
</BODY>
</HTML>
ENDOFFILE

##-----------------------------------------------##
##  END OF JOB.                 
##-----------------------------------------------##

$dbh->disconnect;   

exit;
