#!/usr/opt/perl5.00503/bin/perl5.00503
#print "Content-type: text/html\n\n";

use DBI;
use DBD::Oracle qw(:ora_types);

require "SYS_PROFILE";                     ## System Profile

require "$BINDIR/cgi-lib2.pl";             ## Perl Handling Sub-routines
require "$BINDIR/currency.pl";             ## Currency Format Sub-routine
require "$BINDIR/sp_parm_fmt.pl";          ## SP Input Format Sub-routine
require "$BINDIR/DEFAULT_FONTS";           ## Default Fonts
require "$BINDIR/ORACLE_CONNECTION";       ## Oracle DB Connection Routine

if ($dbh eq '') { print "$FA Connection to Oracle Failed."; exit; }

require "$HOMEDIR/security_check.pl";      ## Check Security Access Level
$RC = &security_check;

if ($ACCESS eq '') {
    @proglist = ("security_violation.cgi");
    system(@proglist);
    exit;
  }

print "Content-type: text/html\n\n";

##-----------------------------------------------##
##  BEGINNING OF JOB.           
##-----------------------------------------------##

$SCRIPT = 'oas_dbspace.cgi';

&ReadParse(*input);

#print $input;
#exit;

##-------------------------------------------------------------##
## Select Table Layout
##-------------------------------------------------------------##

$stmt = $dbh->prepare("
BEGIN  OPEN :cursor FOR 
  select owner
       , table_name
       , column_name
       , data_type
       , data_length
       , data_precision
       , data_scale
       , nullable
       , column_id
    from sys.all_tab_columns
   where owner like 'OAS%'
     and table_name like '$input{'TBNAME'}'
   order by table_name
          , column_id
        ;
END;
     ") or DBI::errstr;

$stmt->bind_param_inout(":cursor", \$sth2, 0, { ora_type => ORA_RSET } );
$stmt->execute;

$i=0;
while ( @data = $sth2->fetchrow_array() ) {


##-----------------------------------------------##
##  Print the Headings.      
##-----------------------------------------------##
if ($i eq 0) {

print <<ENDOFFILE;
<HTML>
<TITLE> OAS DATABASE TABLE LAYOUT $SERVER </TITLE>
<BODY bgcolor=$BC>
<TABLE width=500 bgcolor=$C1 border=1>
<TR $AL >
<TD $CS=2>$F1<b> TABLE: $data[0].$data[1]
<TD $AC><A HREF=index.html> $F1B Menu </A> $NB
<b>
<TR $AL >
<TD $CS=1>$F1 COLUMN
<TD $CS=1>$F1 TYPE
<TD $AC $CS=1>$F1 NULL 
</b>
</TR>
ENDOFFILE
   }
   
$data[5] =~ s/ //gi;
$data[6] =~ s/ //gi;

$FIELD = $data[3]."(".$data[4].")";
if ($data[5] ne '') { $FIELD = $data[3]."(".$data[5].",".$data[6].")"; }

print <<ENDOFFILE;
<TR bgcolor=$C2>
<TD $AL >$F2 $data[2] </TD>
<TD $AL >$F2 $FIELD </TD>
<TD $AC >$F2 $data[7] </TD>
ENDOFFILE

$i++;

} 

$stmt->finish;

print <<ENDOFFILE;
<TR bgcolor=$C1>
<TD $CS=3>$F2 NUMBER OF COLUMNS: $i
</TABLE> 
ENDOFFILE


##-------------------------------------------------------------##
## Select Indexes
##-------------------------------------------------------------##

$stmt = $dbh->prepare("
BEGIN  OPEN :cursor FOR 
  select index_owner
       , index_name
       , column_name
       , column_position
    from sys.all_ind_columns
   where table_owner like 'OAS%'
     and table_name like '$input{'TBNAME'}'
   order by index_name
          , column_position
        ;
END;
     ") or DBI::errstr;

$stmt->bind_param_inout(":cursor", \$sth2, 0, { ora_type => ORA_RSET } );
$stmt->execute;

$i=0;
while ( @data = $sth2->fetchrow_array() ) {


##-----------------------------------------------##
##  Print the Headings.      
##-----------------------------------------------##
if ($data[1] ne $DATA1) {

print <<ENDOFFILE;
</TABLE>
<P>
<TABLE width=500 bgcolor=$C1 border=1>
<TR $AL >
<TD $CS=6>$F1<b> INDEX: $data[0].$data[1]
<b>
<TR $AL >
<TD $CS=1>$F1 COLUMN
</b>
</TR>
ENDOFFILE
   }
   
print <<ENDOFFILE;
<TR bgcolor=$C2>
<TD $AL >$F2 $data[2] </TD>
ENDOFFILE

$DATA1 = $data[1];

$i++;

} 

$stmt->finish;


##-----------------------------------------------##
##  END OF REPORT.              
##-----------------------------------------------##

ENDIT:

$ENDDT = `date +%T`;
chop($ENDDT);

print <<ENDOFFILE;
</TABLE>
<P>
<pre>
<font face=arial size=-1>Beg:$BEGDT
<font face=arial size=-1>End:$ENDDT
</pre>
</FORM>
<font face=arial size=+1 color=blue>
</BODY>
</HTML>
ENDOFFILE


##-----------------------------------------------##
##  END OF JOB.                 
##-----------------------------------------------##

$dbh->disconnect;   

exit;
